/**
 * Static class with methods that return a boolean value casted
 * from JRelix representation of boolean in JAVA's byte type.
 *
 * @since jRelCaNu 2002-07
 */


import java.util.*;


public class CastToBool implements Constants, TypeConstants {  

    public static boolean value(byte castFromBoolByte) 
        throws InterpretError {
        if (castFromBoolByte == (byte) BOOL_TRUE) 
            return true;
        else if (castFromBoolByte == (byte) BOOL_FALSE) 
            return false;
        else if (castFromBoolByte == (byte) BOOL_DK)
            throw new InterpretError(
                    "CastToBool.value: error: Can't cast from BOOL_DK.");
        else if (castFromBoolByte == (byte) BOOL_DC)
            throw new InterpretError(
                    "CastToBool.value: error: Can't cast from BOOL_DC.");
        else 
            throw new InterpretError(
                    "CastToBool.value: error: Can't cast from unknown BOOL.");
    }
}
