
public interface Constants
{
   static final int OP_EOF    =  -4;   //end of file
   static final int OP_IGNORE =  -3;   //ignore
   static final int OP_ERROR  =  -1;   //error opcode

   // *********** Command ***********

   static final int OP_COMMAND   =  0; //command
   static final int OP_HELP   =  1;
   static final int OP_QUIT   =  2;
   static final int OP_INPUT  =  3;
   static final int OP_DEBUG  =  4;
   static final int OP_BATCH  =  5;
   static final int OP_EXPERT =  6;
   static final int OP_TIME   =  7;
   static final int OP_DELD   =  8;
   static final int OP_DELR   =  9;
   static final int OP_PR     =  10;
   static final int OP_SC     =  19;
   static final int OP_SD     =  11;
   static final int OP_SR     =  12;
   static final int OP_SRD    =  13;
   static final int OP_PRINT  =  14;
   static final int OP_SSD         =       15;
   static final int OP_SSR         =       16;
   static final int OP_TRACE = 17;
   static final int OP_ST       =  18; // Jiantao
   static final int OP_DELT     =  20; //Jiantao
   static final int OP_PT       =  21; //Jiantao
   static final int OP_DISP     =  22; //Lili


   // *********** Statement ***********

   // Statement and its combination
   static final int OP_STATEMENT =  100;  //statement
   static final int OP_SEQUENCE  =  101;
   static final int OP_PARALLEL  =  102;
   static final int OP_CHOICE =  103;
   static final int OP_COMPCALL  =       104;
   static final int OP_CONDITIONAL =       105;
   static final int OP_FORLOOP     =       106;
   static final int OP_WHILELOOP   =       107;
   static final int OP_EXIT   =  108;
   static final int OP_DEADLOCK  =  109;
   static final int OP_EXEC   =  110;
   static final int OP_STMTBLOCK =  111;

   // Declaration statement
   static final int OP_DECLARATION  =  140;  //declaration
   static final int OP_RELATION  =  141;
   static final int OP_VIEW   =  142;
   static final int OP_DOMAIN =  143;
   static final int OP_LET    =  144;
   static final int OP_COMPUTATION  =  145;
   static final int OP_DECLARE  =  146;  //Jun 04,2004 by Yu example: declare t1 integer;

   
   // Assignment statement
   static final int OP_ASSIGNMENT   =  160;  //assignment
   static final int OP_ASSIGN =  161;
   static final int OP_ASSIGNADD =  162;

   // Update statement
   static final int OP_UPDATE =  180;  //update
   static final int OP_ADD    =  181;
   static final int OP_DELETE =  182;
   static final int OP_CHANGE =  183;
   static final int OP_USING  =  184;  //using


   //Gedit statement
   static final int OP_GEDIT =  190;   //Gedit
   static final int OP_CONTAINS = 191;
   static final int OP_WITHIN = 192;
   static final int OP_CMPCONTAINS = 193;
   static final int OP_CMPWITHIN = 194;
   static final int OP_INTERSECT = 195;
   static final int OP_WITHINDIST = 196;

   // *********** Others in statement ***********

   // Initialization
   static final int OP_INIT   =  200;  //init
   //static final int OP_ASSIGN  =       161;
   static final int OP_RCOPY  =  201;
   static final int OP_ISCOPY =  202;

   // Constant
   static final int OP_CONSTANT  =  210;  //constant
   static final int OP_UNIONCONSTANT = 213; // unionconstant
   static final int OP_TUPLELIST =  211;
   static final int OP_TUPLE  =  212;

   // Statement list
   static final int OP_STMTLIST  =  220;  //statement list

   // Identifier
   static final int OP_IDENTIFIER   =  230;  //identifier

   // File path
   static final int OP_FILEPATH  =  240;  //filepath

   // *********** Expression ***********

   // Operator type
   static final int OP_BIOPERATOR   =  300;  //binary operator
   static final int OP_JOINOPERATOR=   301;  //binary join operator
   static final int OP_UOPERATOR =  302;  //unary operator
   static final int OP_QTOPERATOR   =  304;  //QT operator
   static final int OP_RED    =  306;  //red
   static final int OP_EQUIV  =  308;  //equiv
   static final int OP_FUN    =  310;  //fun
   static final int OP_PAR    =  312;  //par
   static final int OP_BIGREP =  313;  //biary grep operator by Jiantao
   static final int OP_TEXT2ATTR      =  314;  //text2attr operator by Jiantao
   static final int OP_MU2NEST        =  315;  //mu2nest operator by Jiantao
   static final int OP_DISP2D        =  316;  //display2D by Lili



   // Binary operator : sub of OP_BIOPERATOR
   static final int OP_OR     =  320;
   static final int OP_AND    =  321;
   static final int OP_SUBSTR =  322;
   static final int OP_EQ     =  323;
   static final int OP_NEQ    =  324;
   static final int OP_GT     =  325;
   static final int OP_LT     =  326;
   static final int OP_GE     =  327;
   static final int OP_LE     =  328;
   static final int OP_CAT    =  329;
   static final int OP_MIN    =  330;
   static final int OP_MAX    =  331;
   static final int OP_PLUS   =  332;
   static final int OP_MINUS  =  333;
   static final int OP_MUL    =  334;
   static final int OP_DIV    =  335;
   static final int OP_MOD    =  336;
   static final int OP_POW    =  337;
   static final int OP_PRED   =  338;
   static final int OP_SUCC   =  339;
   static final int OP_CAST   =  340;
   // Mu-Join operator
   static final int OP_NOP    =  360;
   static final int OP_IJOIN  =  361;
   static final int OP_UJOIN  =  362;
   static final int OP_SJOIN   =   363;
   static final int OP_LJOIN   =   364;
   static final int OP_RJOIN   =   365;
   static final int OP_DLJOIN  =   366;
   static final int OP_DJOIN   =   366; // DJOIN is DLJOIN
   static final int OP_DRJOIN  =   367;
   // Sigma-Join operator
   static final int OP_SHIFT  =  10;   //shift for not
   static final int OP_ICOMP  =  380;
   static final int OP_EQJOIN =  381;
   static final int OP_GTJOIN =  382;
   static final int OP_GEJOIN =  383;
   static final int OP_LTJOIN =  384;
   static final int OP_LEJOIN =  385;
   static final int OP_IEJOIN =  386;
   // Not-Sigma-Join operator
   static final int OP_NOTICOMP  =  390;
   static final int OP_NOTEQJOIN =  391;
   static final int OP_NOTGTJOIN =  392;
   static final int OP_NOTGEJOIN =  393;
   static final int OP_NOTLTJOIN =  394;
   static final int OP_NOTLEJOIN =  395; 
   static final int OP_NOTIEJOIN =  396;

   // Unary operator : sub of OP_UOPERATOR
   static final int OP_UPLUS  =  400;
   static final int OP_UMINUS =  401;
   static final int OP_UNOT   =  402;
   static final int OP_PICK   =  403;
   static final int OP_EVAL   =  404;
   static final int OP_ATTRIBSOF   =  405;
   static final int OP_QUOTE   =  406;
   static final int OP_QUOTEIDENT   =  407; //QuoteIdentifier()
   static final int OP_TRANSPOSE   =  408;
   static final int OP_TRANSPOSENEW   =  409;  // Fan Guo June 2004  
   static final int OP_TYPEOF   =  415;		   // Fan Guo June 2004
   static final int OP_SELF   =  416;		   // Fan Guo June 2004   
   static final int OP_GREP   =  417;   //May 17, 2004 by Yu


   // Quantifier operator : sub of OP_QTOPERATOR
   static final int OP_DOT    =  410;
   static final int OP_PERCENT   =  411;
   static final int OP_NUMBER =  412;

   // Projection and Selection
   static final int OP_PROJECTOR =  420;  //projector
   static final int OP_PROJECT   =  421;  //project
   static final int OP_TSELECT   =  422;  //TSelect
   static final int OP_SELECT =  423;  //selector
   static final int OP_QSELECT   =  424;  //Qselector
   static final int OP_WHEREIN   =  425;
   static final int OP_WHEREFROM =  426;
   static final int OP_WHENIN =  427;  //also for in
   static final int OP_WHENFROM  =  428;  //also for from
   static final int OP_EDIT   =  429;  //sub of selector
   static final int OP_ZORDER =  430;  //sub of selector

   // Type opcode and sub opcode
   static final int OP_TYPE   =       450;   //type
   static final int OP_BOOLEAN   =       451;
   //static final int OP_BOOLEAN = 449;  //Yi Zheng Oct 5, 2002
   static final int OP_SHORT  =       452;
   static final int OP_INTEGER   =       453;
   static final int OP_LONG   =       454;
   static final int OP_FLOAT  =       455;
   static final int OP_DOUBLE =       456;
   static final int OP_NUMERIC =457;
   static final int OP_STRING =       458;
   static final int OP_TEXT   =       459;
   static final int OP_STMT   =       460;
   static final int OP_EXPR   =       461;
   static final int OP_COMP   =       462;
   static final int OP_IDLIST =       463;
   static final int OP_RECURSIVE =    464; //Recursive data type  by zhan
   static final int OP_GIDLIST =       465; //JUN 01,2004 BY Yu
   static final int OP_MIDLIST =       466; //JUN 02,2004 BY Yu
   static final int OP_ATTRIBUTE   =  469;//such that OP_ATTRIBUTE-OP_BOOLEAN = 18
   static final int OP_UNIVERSAL   =  476;//such that OP_UNIVERSAL-OP_BOOLEAN = 25
   static final int OP_UNDEF =      478; //Jiantao 2004, so that OP_UNDEF-OP_BOOLEAN = 27, 26 is occupied by zhan :(


   // Literal
   static final int OP_LITERAL   =  470;  //literal
   static final int OP_NULL   =  471;
   static final int OP_DC     =  472;
   static final int OP_DK     =  473;
   static final int OP_TRUE   =  474;
   static final int OP_FALSE  =  475;
   // OP_SHORT, OP_INTEGER, OP_LONG, OP_FLOAT, OP_DOUBLE, OP_STRING

   // Pattern
  static final int OP_Type   =  481;//such that OP_Type-OP_BOOLEAN = 30
  static final int OP_PATTERN   =  476;  //PATTERN     //May 26,2004 by Yu

;

   // domain function opcode
   static final int OP_FUNCTION  =  500;  //function
   static final int OP_ABS    =  501;
   static final int OP_SQRT   =  502;
   static final int OP_SIN    =  503;
   static final int OP_ASIN   =  504;
   static final int OP_COS    =  505;
   static final int OP_ACOS   =  506;
   static final int OP_TAN    =  507;
   static final int OP_ATAN   =  508;
   static final int OP_SINH   =  509;
   static final int OP_COSH   =  510;
   static final int OP_TANH   =  511;
   static final int OP_LOG    =  512;
   static final int OP_LOG10  =  513;
   static final int OP_ROUND  =  514;
   static final int OP_CEIL   =  515;
   static final int OP_FLOOR  =  516;
   static final int OP_ISKNOWN   =  517;
   static final int OP_CHR    =  518;
   static final int OP_ORD    =  519;
   static final int OP_ISNULLDC =  520;                //June 2005 by Rong Li
   static final int OP_ISNULLDK =  521;                //June 2005 Rong Li
   static final int OP_ISNULL   =  522;                //June 2005 Rong Li


   // Quantifier list
   static final int OP_QTLIST =  550;  //quantifier list
   static final int OP_QUANTIFIER   =  552;  //quantifier

   // Array
   static final int OP_ARRAY  =  560;  //array
   static final int OP_INDEXLIST =  562;  //array index list

   // Positional renaming
   static final int OP_RENAME =  570;  //positional rename

   // If-then-else expression
   static final int OP_IFTHENELSE   =  580;  //if-then-else-expr

   static final int OP_EXPRESSION   =  590;  //expression
   static final int OP_EXPRLIST  =  592;  //expression list

   // *********** Computation ***********

   static final int OP_PARALIST  =  600;  //parameter list
   static final int OP_PARAMETER =  602;  //parameter
   static final int OP_CALLPARALIST=   610;  //call para list
   static final int OP_CALLPARA  =  612;  //call para

   static final int OP_COMPNAME  =  640;  //computation name
   static final int OP_COMPIDENTIFIER  =  641;  //identifier of computation
   static final int OP_EVENTNAME  =  642;  //event name
   static final int OP_UNDO  =  644;  // undo the update event
   static final int OP_EVENTON  =  646;  // turn on the event
   static final int OP_EVENTOFF  =  648;  // turn off the event
   static final int OP_COMPBODY  =  650;  //comp body
   static final int OP_COMPBLOCK =  660;  //comp block
   static final int OP_COMPVARDECL  =  670;  //comp var decl
   static final int OP_LOCALVARDECL=   672;  //local var decl
   static final int OP_STATEVARDECL=   674;  //state var decl
   static final int OP_COMPINIT  =  680;  //comp init
   static final int OP_VARINIT   =  682;  //var init
   static final int OP_PREFIX  =  690;  //prefix
   static final int OP_POST  =  692;  //pre prefix
   static final int OP_PRE  =  694;  //post prefix
   static final int OP_ACTION  =  696;  //action

   static final int OP_REDFUNCALL = 701; //function call used in vertical expression
   // start Zongyan's addition
   static final boolean Debug = false; // turn on/off debug

   // ************ Aldatp *******************
   static final int OP_ALDATP = 1000;
   static final int ALDATP_DECLARATION = 1140;
   static final int ALDATP_ASSIGNMENT = 1160;
   static final int ALDATP_UPDATE = 1180;

   // ************ XML **********************
   static final int OP_XML = 702; //zhan


   // start Jiantao
   // ********** Binary Grep ********* 
   static final int OP_IGREP  =  801;
   static final int OP_UGREP  =  802;
   static final int OP_SGREP  =  803;
   static final int OP_DGREP  =  804;
   static final int OP_LGREP  =  805;
   static final int OP_RGREP  =  806;

   // Range-Join operator
   static final int OP_LOJOIN = 831;
   static final int OP_HIJOIN = 832;
   
   // mu2nest
   static final String ABSOLUTE_POS = ".abspos";
   static final String RELATIVE_POS = ".relativepos";
   static final String DOM_UNANALYZED = ".unanalyzed";
   static final int BUF_SIZE  = 16 * 1024;   
   // end Jiantao

   // ********** INSQL *********
   static final int OP_INSQL = 2000;
   static final int OP_INSQLFILE = 2001;
   // ********** EXPSQL *********
   static final int OP_EXPSQL = 2002;
   static final int OP_EXPSQLFILE = 2003;
   
}
