/*CvDraw draws the map and handles all events*/
import javax.swing.*;
//import com.sun.java.swing.*;
import java.io.*;
import java.math.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.awt.Point;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;

public class CvDraw extends JPanel implements TypeConstants
{

 private  Relation rl=null;
 private  Domain[] doms;
 private  int[] minmax=new int[4];

 public CvDraw(Relation rel,Domain[] domains, int[] MinMax){
  rl=rel;
  doms=domains;
  minmax=MinMax;
  }//end of CvDraw()

  public void  setData(Relation rel,Domain[] domains, int[] MinMax){
   rl=rel;
   doms=domains;
   minmax=MinMax;
   //System.out.println("start to repaint");
   repaint();
   }//end of setData

//rewrite the paintComponent()to draw the map
 public void paintComponent(Graphics g) 
  { 
  super.paintComponent(g);

  if(rl!=null)
  {
    Dimension d=getSize();
    int dX=d.width-1,dY=d.height-1;


    //g.setColor(getForeground());

    //get minX,minY,maxX,maxY, factorX,factorY

    int minX=minmax[0];
    int maxX=minmax[1];
    int minY=minmax[2];
    int maxY=minmax[3];
    int iColor=0,fiColor=0;
    int iSymbol=0,fiSymb=0;
    int pG=rl.indexOfDomain(doms[0]); 
    int pT=rl.indexOfDomain(doms[1]); 
    int pS=rl.indexOfDomain(doms[2]); 
    int pX=rl.indexOfDomain(doms[3]); 
    int pY=rl.indexOfDomain(doms[4]); 
    int pColor=rl.indexOfDomain(doms[5]); 
    int pSymbol=rl.indexOfDomain(doms[6]);
    int pLayer=rl.indexOfDomain(doms[7]);
    int pName=8;
    int numtuples=rl.numtuples;
    int iSeq=0,fX=0,fY=0,iX=0,iY=0;    
    int X=0,Y=0;
    String sG="",sT="",fG="",fT="";
    String sName="";
    Object[] data=rl.data;
    int xval[]=new int[rl.numtuples];
    int yval[]=new int[rl.numtuples];

    double facX=((double)maxX-(double)minX)/(double)dX;
    double facY=((double)maxY-(double)minY)/(double)dY;
    double factorX, factorY;
    factorX=factorY=Math.max(facX,facY);

    Domain[] domains=rl.domains;
    int[] types = rl.toTypes(domains);//domain types
    //width is the size of symbol being drawn
    int wid=Math.min(getSize().width,getSize().height);
    int width=(int)(((double)wid)*(((double)(25))/((double)1024)));
   try
    {
     int j=0; //j is the subscript of xval[] and yval[] of polygons
     for (int i=0;i<numtuples;i++)
     {
      if(types[pG]!=STRING) { throw new GeditError("expecting type STRING");}
      else
        sG=((String[])data[pG])[i];

      if(types[pT]!=STRING){ throw new GeditError("expecting type STRING");}
      else
        sT=((String[])data[pT])[i];

      if(types[pName]!=STRING){ throw new GeditError("expecting type STRING");}
      else
        sName=((String[])data[pName])[i];

      if(types[pS]!=INTEGER){ throw new GeditError("expecting type INTEGER at pS="+pS+" the type is="+types[pS]);}
      else
        iSeq=((int[])data[pS])[i];

      if(types[pX]!=INTEGER){ throw new GeditError("expecting type INTEGER at pX="+pX);}
      else
        iX=((int[])data[pX])[i];

      if(types[pY]!=INTEGER){ throw new GeditError("expecting type INTEGER at pY="+pY);}
        iY=((int[])data[pY])[i];

      if(types[pColor]!=INTEGER){ throw new GeditError("expecting type INTEGER at pColor="+pColor);}
        iColor=((int[])data[pColor])[i];

      if(types[pSymbol]!=INTEGER){ throw new GeditError("expecting type INTEGER at pSymbol="+pSymbol);}
        iSymbol=((int[])data[pSymbol])[i];

      //convert screen Longitude(iX)and latitude(iY) to screen pixcels X,Y
      if(factorX!=0)
       {
        if(iX>=0) X=(int)((double)dX-((double)iX-(double)minX)/factorX);
        else
	    X=(int)((double)dX-((double)maxX-(double)iX)/factorX);
       }
      else X=iX;
      if(factorY!=0)
       {
        if(iY>=0)
        Y=(int)((double)dY-((double)iY-(double)minY)/factorY);
        else Y=(int)((double)dY-((double)maxY-(double)iY)/factorY);
       }
      else 
        Y=iY;
 // System.out.println("X="+X);
      if(sG.compareTo(fG)!=0||i==0)   //new group
           {
             //draw the former group;
              if((fT.toUpperCase()).compareTo("POINT")==0)
	      {
	       GeditGraph.chooseColor(g,fiColor);
	       GeditGraph.drawSymb(g,fX,fY,fiSymb,width,dX,dY);
	      // System.out.println("fiSymb="+fiSymb);
               //g.fillOval(fX,fY,5,5);
	      }

              if((fT.toUpperCase()).compareTo("POLYGON")==0)
	       {
	       int cxval[]=compressArray(xval,j);
	       int cyval[]=compressArray(yval,j);
               GeditGraph.chooseColor(g,fiColor);
	       g.fillPolygon(cxval,cyval,cxval.length);
	       g.setColor(Color.yellow);

	       g.drawPolygon(cxval,cyval,cxval.length);
	       xval=new int[rl.numtuples]; //clear the polygon array
	       yval=new int[rl.numtuples];
	       j=0;

	       }
              if((sT.toUpperCase()).compareTo("POLYGON")==0)
	      {
	       xval[j]=X;
	       yval[j]=Y;
	       j++;
	       }
	

              //fX is the predecessor of X
              //fY is the predecessor of Y
              //fG is the predecessor of sG
              //fT is the predecessor of sT
	      fX=X;fY=Y; fT=sT;fG=sG; fiColor=iColor;fiSymb=iSymbol;
	   }
	   else{ //not new group
              if((fT.toUpperCase()).compareTo("POLYLINE")==0)
	      {
	       GeditGraph.chooseColor(g,fiColor);
                g.drawLine(fX,fY,X,Y);
		}

              if((fT.toUpperCase()).compareTo("POLYGON")==0)
	        {xval[j]=X;
		 yval[j]=Y;
		 j++;
		}
	      
              //fX is the predecessor of X
              //fY is the predecessor of Y
              //fG is the predecessor of sG 
              //fT is the predecessor of sT 
	      fX=X;fY=Y;fT=sT;fG=sG; fiColor=iColor;fiSymb=iSymbol;
             }
       }//end of for loop

             //draw the last group;
              if((fT.toUpperCase()).compareTo("POINT")==0)
	      {
	      GeditGraph.chooseColor(g,fiColor);
	      GeditGraph.drawSymb(g,fX,fY,fiSymb,width,dX,dY);
	       //System.out.println("fiSymb="+fiSymb);

              //g.fillOval(fX,fY,15,15);
	      }

              if((fT.toUpperCase()).compareTo("POLYGON")==0)
	       {
	       int cxval[]=compressArray(xval,j);
	       int cyval[]=compressArray(yval,j);
		GeditGraph.chooseColor(g,iColor);
	       g.fillPolygon(cxval,cyval,cxval.length);
	       g.setColor(Color.yellow);
	       g.drawPolygon(cxval,cyval,cxval.length);

	       }
       }catch(GeditError ge){System.out.println(ge.getMessage());ge.printStackTrace();System.exit(-1);}

  }//end of if (rl!=null)
}//end of paint() 

private int[] compressArray(int[] oldarray,int len)
{
 int newarray[]=new int[len];
 for(int i=0;i<len;i++)
  newarray[i]=oldarray[i];
 return(newarray);
}










}//end of CvDraw class
