
/**
*Class GeditAbout.
*
* The dialog showing the description of current Geditor version.
*
* @autor YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditAbout extends JDialog implements ActionListener,TypeConstants{
  private JLabel banner=new JLabel("Geditor for JRelix");
  private JLabel version=new JLabel("Version 1.0");
  private JLabel author=new JLabel("by YuLing Chen");
  private JLabel copyright=new JLabel("Copyright 2000    McGill University");
  private JButton okbutton=new JButton("ok");
  private boolean ok=false;

  public GeditAbout(Geditor geditor)
  {
    super((JFrame)geditor, "About",true);
    Container contentpane=getContentPane();
     Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/3;
     int hgt=dhgt/3;

     okbutton.addActionListener(this);
     Border etched = BorderFactory.createEtchedBorder();

  banner.setForeground(Color.yellow);
  banner.setBackground(Color.blue);
  banner.setOpaque(true);
  banner.setFont(new Font("SansSerif", Font.BOLD,24));
  version.setForeground(Color.yellow);
  version.setBackground(Color.blue);
  version.setOpaque(true);
  version.setFont(new Font("SansSerif", Font.BOLD,16));

  JPanel upperp=new JPanel();
  upperp.setBackground(Color.blue);
  GridBagLayout gbl=new GridBagLayout();
  upperp.setLayout(gbl);
  GridBagConstraints cons=new GridBagConstraints();
  GeditGlobal.add(upperp,banner,cons,0,0,1,1);
  GeditGlobal.add(upperp,version,cons,0,1,1,1);

  author.setForeground(Color.black);
  author.setFont(new Font("Helvetica", Font.ITALIC,18));
  author.setOpaque(true);
  copyright.setFont(new Font("Helvetica", Font.PLAIN,16));
  copyright.setForeground(Color.black);
  copyright.setOpaque(true);
     JPanel buttonp=new JPanel();
     buttonp.add(okbutton);

  JPanel lowerp=new JPanel();
  GridBagLayout gbag=new GridBagLayout();
  lowerp.setLayout(gbag);
  GridBagConstraints cs=new GridBagConstraints();
  cs.weightx=100;
  cs.weighty=100;
  cs.fill=GridBagConstraints.BOTH;
  GeditGlobal.add(lowerp,author,cs,0,0,1,1);
  GeditGlobal.add(lowerp,copyright,cs,0,1,1,1);

  JPanel p=new JPanel();
  GridBagLayout gb=new GridBagLayout();
  p.setLayout(gb);
  GridBagConstraints c=new GridBagConstraints();
  c.weightx=100;
  c.weighty=100;
  c.fill=GridBagConstraints.BOTH;
  upperp.setBorder(etched);

  GeditGlobal.add(p,upperp,c,0,0,1,2);
  c.anchor=GridBagConstraints.SOUTH;
  c.insets=new Insets(40,0,0,0);
  GeditGlobal.add(p,lowerp,c,0,2,1,2);
  c.insets=new Insets(0,0,0,0);
  GeditGlobal.add(p,buttonp,c,0,4,1,1);

  p.setBorder(BorderFactory.createTitledBorder(etched, "About"));


  contentpane.add("Center",p);
  setSize(wid,hgt);
    }

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
       if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
}//end of actionPerformed

public boolean showDialog()
{  ok=false;
     show();
     return(ok);

}

}
