
/**
*Class GeditAddLayers.
*
* The dialog of Add Layers.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class GeditAddLayers extends JDialog implements ActionListener
{
     private boolean ok;
     private Hashtable lgdhtb;
     //left list
     private JList layerlist=null;

     //right list
     private DefaultListModel model=new DefaultListModel();
     private JList chosenlist=new JList(model);

     //Buttons in ButtonPanel
     private JButton addButton=new JButton("  Add      ->");
     private JButton removeButton=new JButton("Remove  <-");
     private JButton cancelButton=new JButton("  Cancel ");
     private JButton okButton=new JButton("    Ok    ");
     private String[] layersall;
     //the messagelabel
     private JLabel messagelabel=new JLabel("Choose a layer from left list and add to right list");

  public GeditAddLayers(JFrame parent, String[] allayers,String[] showlayers,Hashtable legendhtb)
    {
     super(parent, "Add Layer",true);
     Container contentpane=getContentPane();

     lgdhtb=legendhtb;
     layersall=allayers;
     //the top panel
     JPanel p=new JPanel();
     p.setLayout(new BorderLayout());

     //the second panel
     JPanel p0=new JPanel();
     p0.setLayout(new BorderLayout());


     JPanel p1=new JPanel();

     Dimension d=parent.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;

     layerlist=new JList(allayers);
     layerlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     layerlist.setFixedCellWidth(wid/5);
     layerlist.setFixedCellHeight(hgt/12);
     JScrollPane scrollpane1=new JScrollPane(layerlist);
     p1.add(scrollpane1);


     //the middle buttonpanel

     JPanel buttonbox=new JPanel();
     buttonbox.setLayout(new BoxLayout(buttonbox,BoxLayout.Y_AXIS));
    // buttonbox.add(Box.createRigidArea(new Dimension(15,15)));
     buttonbox.add(addButton);
     buttonbox.add(removeButton);

     addButton.addActionListener(this);
     removeButton.addActionListener(this);
     cancelButton.addActionListener(this);
     okButton.addActionListener(this);

     p1.add(buttonbox);

     //initiate the chosenlist
     //add the current showlayers into the chosenlist
     chosenlist.setFixedCellWidth(wid/5);
     chosenlist.setFixedCellHeight(hgt/12);
     chosenlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     if(showlayers!=null && legendhtb!=null)
     {
      for(int i=0;i<showlayers.length;i++)
      {
        GeditLegend[] legendarray=(GeditLegend[])legendhtb.get(showlayers[i]);
	if(legendarray==null) System.out.println("legendarray is null");
        if(legendarray[0].getVisible()) 
            model.addElement(showlayers[i]);
       }
     }
       JScrollPane scrollpane2=new JScrollPane(chosenlist);
       p1.add("East",scrollpane2);

       messagelabel.setForeground(((Geditor)parent).messagecolor);

       JPanel p2=new JPanel();
       p2.add(messagelabel);

       p0.add("Center", p1); 
       p0.add("South", p2);

     JPanel buttonp=new JPanel();
     buttonp.add(okButton);
     buttonp.add(cancelButton);
     p.add("Center",p0);
     p.add("South",buttonp);
     Border etched = BorderFactory.createEtchedBorder();
     p.setBorder(BorderFactory.createTitledBorder(etched,"Add Layer"));

     contentpane.add("Center",p);
     setSize(wid,hgt);
     }

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
   if(source==addButton)
     {
       String selection=(String)layerlist.getSelectedValue();
       //change the message accordingly
       if(selection==null)
          messagelabel.setText("Please select a layer from the left list before Add."); 
	else{ if(notRepeat(selection)) 
	     {model.addElement(selection);
     
              messagelabel.setText("Choose a layer from left list and add to right list");}
	      else messagelabel.setText("The layer being added is duplicate");

	   }

     }
     else if(source==removeButton)
        { String selection=(String)chosenlist.getSelectedValue();
	   //change the message accordingly
	  if(selection==null)
	    messagelabel.setText("Please select a layer from the right list before remove.");
	  else{ model.removeElement(selection);
          messagelabel.setText("Choose a layer from left list and add to right list");
	  }
	}

     else if(source==cancelButton)
        setVisible(false);
     else if(source==okButton)
       {ok=true;
        setVisible(false);
	}
}//end of actionPerformed

public boolean notRepeat(String selection)
{
  int len=model.size(); 
  for(int i=0;i<len;i++)
  {if (((String)(model.elementAt(i))).equals(selection))
    return(false);
    }
  return(true);
}

public boolean showDialog(Geditor geditor)
{  ok=false;

   show();
   if(ok)
    {
     //update of legend hashtable
     geditor.showlayers=new String[chosenlist.getModel().getSize()];
     //clear the legend table
     for(int i=0;i<layersall.length;i++)
     {
      GeditLegend[] lgdarray=(GeditLegend[])lgdhtb.get(layersall[i]);
      for(int j=0;j<lgdarray.length;j++)
      {
         lgdarray[j].setVisible(false);
         lgdarray[j].setActive(false);
      }
     }
     String activename=null;
     //update legend table
     for(int i = 0; i < chosenlist.getModel().getSize(); i++) {
       String name=(String)(chosenlist.getModel().getElementAt(i));
       geditor.showlayers[i]=name;
       GeditLegend[] lgdarray=(GeditLegend[])lgdhtb.get(name);
       for(int j=0;j<lgdarray.length;j++)
        {
         lgdarray[j].setVisible(true);
	 if(i==(chosenlist.getModel().getSize())-1)
	  {lgdarray[j].setActive(true);
	   activename=lgdarray[j].name;
	    //if the current active layer type is point, enable the symbol
	    //editor menu item
	    if(lgdarray[j].type.toUpperCase().compareTo("POINT")!=0)
	    geditor.symbitem.setEnabled(false);
	    else geditor.symbitem.setEnabled(true);
	    //update the active layer of the identify internal frame
	    if(geditor.identf!=null) geditor.identf.init();
	  }
	}
       geditor.legendhtb.remove(name);
       geditor.legendhtb.put(name,lgdarray);
       //update the active layer map
       if(activename!=null)
       GeditGlobal.updateActiveMap(geditor,activename);
      }//end of update legendarray
    }
   return(ok);
}
}//end of AddLayersDialog class
