
/**
*Class GeditOptions.
*
* The dialog of Options. This dialog allows the user the change the default
* color of the selected map features.
*
* @autor YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditOptions extends JDialog implements ActionListener,TypeConstants{
  private JLabel label=new JLabel("Default color for Expression Builder:");
  private JLabel spqlabel=new JLabel("Default color showing Spatial Query:");
  private JLabel actlabel=new JLabel("Default color  showing  active  layer :");
  private JLabel message=new JLabel("Click the color patch to change the color");
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private boolean ok;
  private Geditor gdt;
  private GeditColorPatch expcolorp=null;
  private GeditColorPatch spqcolorp=null;
  private GeditColorPatch actcolorp=null;

  public GeditOptions(Geditor geditor)
  {
    super((JFrame)geditor, "Options",true);
    Container contentpane=getContentPane();
    ok=false;
    gdt=geditor;
     Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/3;
     int hgt=dhgt/3;

     //construct the button panel
     JPanel buttonp=new JPanel();
     okbutton.addActionListener(this);
     buttonp.add(okbutton);
     cancelbutton.addActionListener(this);
     buttonp.add(cancelbutton);

     //construct the color patch
     expcolorp=new GeditColorPatch(GeditColor.int2color(gdt.selcolor),gdt);
     spqcolorp=new GeditColorPatch(GeditColor.int2color(gdt.spqcolor),gdt);
     actcolorp=new GeditColorPatch(GeditColor.int2color(gdt.activecolor),gdt); 

     Border etched = BorderFactory.createEtchedBorder();


     JPanel inp1=new JPanel();
     GridBagLayout gb=new GridBagLayout();
     inp1.setLayout(gb);
     GridBagConstraints c=new GridBagConstraints();

     c.weightx=0;
     c.weighty=0;
     c.anchor=GridBagConstraints.EAST;
     GeditGlobal.add(inp1,label,c,0,0,1,1);

     c.weightx=100;
     c.weighty=100;
     c.ipadx=30;
     c.ipady=30;
     c.anchor=GridBagConstraints.WEST;
     GeditGlobal.add(inp1,expcolorp,c,1,0,2,2);

     inp1.setBorder(etched);


     JPanel inp2=new JPanel();
     gb=new GridBagLayout();
     inp2.setLayout(gb);
     c=new GridBagConstraints();

     c.weightx=0;
     c.weighty=0;
     c.anchor=GridBagConstraints.EAST;
     GeditGlobal.add(inp2,spqlabel,c,0,0,1,1);

     c.weightx=100;
     c.weighty=100;
     c.ipadx=30;
     c.ipady=30;
     c.anchor=GridBagConstraints.WEST;
     GeditGlobal.add(inp2,spqcolorp,c,1,0,2,2);

     inp2.setBorder(etched);

     JPanel inp3=new JPanel();
      gb=new GridBagLayout();
     inp3.setLayout(gb);
     c=new GridBagConstraints();

     c.weightx=0;
     c.weighty=0;
     c.anchor=GridBagConstraints.EAST;
     GeditGlobal.add(inp3,actlabel,c,0,0,1,1);

     c.weightx=100;
     c.weighty=100;
     c.ipadx=30;
     c.ipady=30;
     c.anchor=GridBagConstraints.WEST;
     GeditGlobal.add(inp3,actcolorp,c,1,0,2,2);

     inp3.setBorder(etched);

     JPanel p=new JPanel();
     p.setLayout(new GridLayout(4,1,1,1));
     p.add(inp1);
     p.add(inp2);
     p.add(inp3);
     p.add(buttonp);

     message.setForeground(gdt.messagecolor);

     p.setBorder(BorderFactory.createTitledBorder(etched,"Options"));
     contentpane.add("Center",p);
     contentpane.add("South",message);

     setSize(wid,hgt);
    }

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
}//end of actionPerformed

public boolean showDialog()
{  ok=false;
     show();
     if(ok)
     {
      //update the default color of the geditor
      gdt.selcolor=GeditColor.color2int(expcolorp.getColor());
      gdt.spqcolor=GeditColor.color2int(spqcolorp.getColor());

      }
     return(ok);

}

}
