
/**
*Class GeditRangeClass.
*
* The dialog of Range Classification of Geditor.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditRangeClass extends JDialog implements TypeConstants, ActionListener,ListSelectionListener{
  //Graphic components
  private JLabel activelayer;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private JList attrlist=null;
  private JList colorrange=null;
  private JTextField r0;
  private JTextField r1;
  private JTextField r2;
  private JTextField r3;
  private JTextField r4;
  private JTextField r5;
  private JPanel rcp;
  GeditColorPatch cp1;
  GeditColorPatch cp2;
  GeditColorPatch cp3;
  GeditColorPatch cp4;
  GeditColorPatch cp5;
  JLabel message;
  private Box rangeb=null;
  private Box colorb=null;

  private boolean ok;
  private Hashtable lgdhtb;
  private String actlayer=null;
  private Relation maprel;
  private int attrnum=0;
  private double min,max;
  public Geditor gdt;
  Color[] redrange;
  Color[] greenrange;
  Color[] bluerange;
  Color[] grayrange;
  private int pos=-1;
  private String classattr;
  private int rgsize=5;
  private boolean onevalue=false;


  public GeditRangeClass(Geditor geditor, String[] allayers,Hashtable legendhtb)
  {
    super((JFrame)geditor, "Range Map",true);
    ok=false;
    gdt=geditor;
    lgdhtb=legendhtb;

    //get active layer
    if(lgdhtb!=null)
    for(int i=0;i<allayers.length;i++)
     actlayer=GeditGlobal.getActiveLayer(gdt);

   if(actlayer!=null)
   {
    JLabel activelayer=new JLabel("Active Layer: "+actlayer);

     maprel=geditor.maprel;
     Domain[] doms=maprel.domains;
     int[] types=maprel.toTypes(maprel.domains);
     String[] attrname=new String[doms.length];
     boolean addattr=true;
     attrnum=0;
     for(int i=0;i<doms.length;i++)
     { 
      addattr=true;
      for(int j=0;j<geditor.dom.length;j++)
      {
      //geditor.dom are graphical attributes
      if (doms[i].name.compareTo(geditor.dom[j].name)==0)
       addattr=false;
       }
       //only number attributes are suitable for range classification
       if(addattr&& (types[i]==INTEGER || types[i]==SHORT||types[i]==LONG||types[i]==FLOAT||types[i]==DOUBLE))
       {
        attrname[attrnum]=doms[i].name;
        attrnum++;
       }
     }
    if( attrnum==0)  message=new JLabel("There's no additional attributes");
    else message=new JLabel("Please select an attribute in the attribute list");

    message.setForeground(gdt.messagecolor);

Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/2;

     attrlist=new JList(attrname);
     attrlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     attrlist.setFixedCellWidth(wid/5);
     attrlist.setFixedCellHeight(hgt/12);
     JScrollPane attrscp=new JScrollPane(attrlist);
     attrlist.addListSelectionListener(this);

     //construct the button panel
     JPanel buttonp=new JPanel();
     okbutton.addActionListener(this);
     okbutton.setEnabled(false);//initially disable okbutton
     buttonp.add(okbutton);
     cancelbutton.addActionListener(this);
     buttonp.add(cancelbutton);

     //title of the lists
     JLabel t_attrs=new JLabel("Attribute List");
     JLabel t_gradedclrs=new JLabel("Graded Colors");
     JLabel t_rangeclrs=new JLabel("Ranges&Colors");

     //graded colors list
     String[] graded_clrs={"red","blue","green","gray"};
     colorrange=new JList(graded_clrs);
     colorrange.setFixedCellWidth(wid/6);
     colorrange.setFixedCellHeight(hgt/12);
     colorrange.setSelectedIndex(0);
     colorrange.addListSelectionListener(this);
     JScrollPane colorscp=new JScrollPane(colorrange);

     //Range values

      r0=new JTextField(20);
      r1=new JTextField(20);
      r2=new JTextField(20);
      r3=new JTextField(20);
      r4=new JTextField(20);
      r5=new JTextField(20);
      r0.setEnabled(false);
      r5.setEnabled(false);
      r1.addActionListener(this);
      r2.addActionListener(this);
      r3.addActionListener(this);
      r4.addActionListener(this);
     
     //Range colors
     redrange=new Color[rgsize];
     bluerange=new Color[rgsize];
     greenrange=new Color[rgsize];
     grayrange=new Color[rgsize];

     redrange[0]=new Color(255,204,204);
     redrange[1]=new Color(255,153,153);
     redrange[2]=new Color(255,51,51);
     redrange[3]=new Color(255,0,51);
     redrange[4]=new Color(153,0,51);
     bluerange[0]=new Color(204,204,255);
     bluerange[1]=new Color(153,153,255);
     bluerange[2]=new Color(102,102,255);
     bluerange[3]=new Color(0,0,255);
     bluerange[4]=new Color(0,0,153);
     greenrange[0]=new Color(204,255,204);
     greenrange[1]=new Color(153,255,153);
     greenrange[2]=new Color(0,255,0);
     greenrange[3]=new Color(0,153,0);
     greenrange[4]=new Color(0,102,0);
     grayrange[0]=new Color(237,237,228);
     grayrange[1]=new Color(184,184,183);
     grayrange[2]=new Color(147,147,146);
     grayrange[3]=new Color(100,100,98);
     grayrange[4]=new Color(66,66,64);

      cp1=new GeditColorPatch(redrange[0],gdt);
      cp2=new GeditColorPatch(redrange[1],gdt);
      cp3=new GeditColorPatch(redrange[2],gdt);
      cp4=new GeditColorPatch(redrange[3],gdt);
      cp5=new GeditColorPatch(redrange[4],gdt);

      //layout the dialog
     rcp=new JPanel();
     GridBagLayout gbag=new GridBagLayout();
     rcp.setLayout(gbag);
     GridBagConstraints cons=new GridBagConstraints();

     cons.weightx=100;
     cons.weighty=100;
     cons.ipady=10;
     cons.ipadx=60;
     cons.fill=GridBagConstraints.BOTH;
    // cons.weighty=0;
     //cons.ipady=0;
     GeditGlobal.add(rcp,r0,cons,0,0,8,1);

    // cons.weighty=100;
     //cons.ipady=10;
     GeditGlobal.add(rcp,cp1,cons,8,1,8,2);

    // cons.weighty=0;
     cons.ipady=0;
     GeditGlobal.add(rcp,r1,cons,0,3,8,1);

     cons.weighty=100;
     cons.ipady=10;
     GeditGlobal.add(rcp,cp2,cons,8,4,8,2);

     //cons.weighty=0;
     cons.ipady=0;
     GeditGlobal.add(rcp,r2,cons,0,6,8,1);

     cons.weighty=100;
     cons.ipady=10;
     GeditGlobal.add(rcp,cp3,cons,8,7,8,2);
     
    // cons.weighty=0;
     cons.ipady=0;
     GeditGlobal.add(rcp,r3,cons,0,9,8,1);

     cons.weighty=100;
     cons.ipady=10;
     GeditGlobal.add(rcp,cp4,cons,8,10,8,2);

    // cons.weighty=0;
     cons.ipady=0;
     GeditGlobal.add(rcp,r4,cons,0,12,8,1);

     cons.weighty=100;
     cons.ipady=10;
     GeditGlobal.add(rcp,cp5,cons,8,13,8,2);

     //cons.weighty=0;
     cons.ipady=0;
     GeditGlobal.add(rcp,r5,cons,0,15,8,1);

     r1.setBorder(BorderFactory.createLineBorder(Color.blue));
     r2.setBorder(BorderFactory.createLineBorder(Color.blue));
     r3.setBorder(BorderFactory.createLineBorder(Color.blue));
     r4.setBorder(BorderFactory.createLineBorder(Color.blue));

     JPanel p=new JPanel();
     GridBagLayout gbl=new GridBagLayout();
     Container contentpane=getContentPane();
     p.setLayout(gbl);
     GridBagConstraints constraints=new GridBagConstraints();
    // constraints.weightx=0;
    // constraints.weighty=0;
     constraints.weightx=100;
     constraints.weighty=100;
     constraints.insets=new Insets(0,0,20,20);
     constraints.ipadx=20;
     constraints.fill=GridBagConstraints.BOTH;
     GeditGlobal.add(p,activelayer,constraints,0,0,3,1);

     constraints.ipady=10;//make this line separate from the first line
     constraints.anchor=GridBagConstraints.SOUTH;
     constraints.insets = new Insets(10,0,0,0);  //top padding
     GeditGlobal.add(p,t_attrs,constraints,0,1,1,1);

     constraints.ipady=20;
     GeditGlobal.add(p,t_gradedclrs,constraints,1,1,1,1);

     constraints.ipady=20;
     GeditGlobal.add(p,t_rangeclrs,constraints,2,1,1,1);

     constraints.ipady=0;
     GeditGlobal.add(p,attrscp,constraints,0,2,1,6);

     constraints.ipadx=20;
     GeditGlobal.add(p,colorscp,constraints,1,2,1,6);

     constraints.ipadx=20;
     GeditGlobal.add(p,rcp,constraints,2,2,1,1);


     //message.setForeground(Color.red);
     constraints.ipadx=0;
     constraints.ipady=40;
     GeditGlobal.add(p,message,constraints,0,8,3,1);


     constraints.ipadx=0;
     constraints.ipady=40;
     GeditGlobal.add(p,buttonp,constraints,0,9,3,1);


     Border etched = BorderFactory.createEtchedBorder();
     p.setBorder(BorderFactory.createTitledBorder(etched,"Range Map"));
    contentpane.add("Center",p);
     setSize(wid,hgt);
}//end of else

}

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
      else if(source==r1||source==r2||source==r3||source==r4)
         {
	  //the range value changed, so check the order of the values. They
	  //should be from smaller to larger
          double r1value=(new Double(r1.getText())).doubleValue();
          double r2value=(new Double(r2.getText())).doubleValue();
          double r3value=(new Double(r3.getText())).doubleValue();
          double r4value=(new Double(r4.getText())).doubleValue();
	    if (r1value<min)
	   message.setText("The first range value <min value in the data set");
	   else if(r4value>max)
	   message.setText("The last range value >max value in the data set");
           else  if(onevalue)
	        {
	         if((r1value!=r2value)||(r2value!=r3value)||(r3value!=r4value))
	     message.setText("The values of ranges are Wrong!");
	         else message.setText("");
	        }
		else { if(! (r1value<r2value && r2value<r3value && r3value<r4value))
	        message.setText("The values of ranges are out of order");
	   else message.setText("");}
	 }
  }

//Handles the selection of attributes list.
//When an attribute is selected in the attribute list, the range values must
//be calculated from obtaining the corresponding values from the maprel.
 public void valueChanged(ListSelectionEvent evt)
 { JList source=(JList)evt.getSource();
 if(source==attrlist)
 {
   //the range value order checks can only be invoked by a return 
   okbutton.setEnabled(true);//activate the okbutton
   message.setText("Type RETRUN after editing the range values.");
   classattr=(String)source.getSelectedValue();
   Domain[] doms=maprel.domains;
     for(int i=0;i<doms.length;i++)
     { 
      //geditor.dom are graphical attributes
      if (doms[i].name.compareTo(classattr)==0)
      {pos=i;break;}
     }
   if(pos==-1)
   {
  GeditGlobal.showErrorDialog((JFrame)gdt,"Attr List Error.");
   }
   else//calculate the range values
   {
   int[] types = maprel.toTypes(maprel.domains);//domain types
   boolean error=false;
   boolean first=true;
   int pL=gdt.pL;
   for(int i=0;i<maprel.numtuples;i++)
   {
   if(((String[])(maprel.data[pL]))[i].compareTo(actlayer)==0)
     {
       if(first)
       {
        min=((int[])(maprel.data[pos]))[i];
        max=((int[])(maprel.data[pos]))[i];
	first=false;
	}
   switch(types[pos])
   {case INTEGER:
       int curint=((int[])(maprel.data[pos]))[i];
       if(curint<min)
        min=curint;
       if(curint>max)
        max=curint;
	break;
    case DOUBLE:
       double curdbl=((double[])(maprel.data[pos]))[i];
       if(curdbl<min)
        min=curdbl;
       if(curdbl>max)
        max=curdbl;
       break;
    case SHORT:
       short cursht=((short[])(maprel.data[pos]))[i];
       if(cursht<min)
        min=cursht;
       if(cursht>max)
        max=cursht;
       break;
    case LONG:
       long curlong=((long[])(maprel.data[pos]))[i];
       if(curlong<min)
        min=curlong;
	if(curlong>max)
	max=curlong;
       break;
    case FLOAT:
        float curflt=((float[])(maprel.data[pos]))[i];
	if(curflt<min)
	 min=curflt;
	 if(curflt>max)
	 max=curflt;
         break;
    default:
      GeditGlobal.showErrorDialog((JFrame)gdt, 
      "The type of selected attribute is not a number.");
      error=true;
      break;
      }
    }//end of if
    }//end of for
    if(!error)
    {
    double gap;
    if (min==max)
     {gap=0;onevalue=true;}
    else//get equal five ranges from the min to max, if there's only one value
        //in the relation, treat it differently
     { gap=(max-min)/5; onevalue=false;}
    Double Gap1=new Double(min+gap);
    Double Gap2=new Double(min+gap*2);
    Double Gap3=new Double(min+gap*3);
    Double Gap4=new Double(min+gap*4);
    Double MIN=new Double(min);
    Double MAX=new Double(max);
    r0.setText(MIN.toString());
    r1.setText(Gap1.toString());
    r2.setText(Gap2.toString());
    r3.setText(Gap3.toString());
    r4.setText(Gap4.toString());
    r5.setText(MAX.toString());
    r0.revalidate();
    r1.revalidate();
    r2.revalidate();
    r3.revalidate();
    r4.revalidate();
    r5.revalidate();
    rcp.revalidate();
     }//end of if(!error)
   }
  }
  else if(source==colorrange)
   {
   //when the user chooses a range color from the list, display the
   //corresponding color ranges
   String clrrg=(String)source.getSelectedValue();
   if(clrrg.compareTo("red")==0)
   {
      cp1.setColor(redrange[0]);
      cp2.setColor(redrange[1]);
      cp3.setColor(redrange[2]);
      cp4.setColor(redrange[3]);
      cp5.setColor(redrange[4]);
   }
   else if(clrrg.compareTo("blue")==0)
   {
      cp1.setColor(bluerange[0]);
      cp2.setColor(bluerange[1]);
      cp3.setColor(bluerange[2]);
      cp4.setColor(bluerange[3]);
      cp5.setColor(bluerange[4]);

   }
   else if(clrrg.compareTo("green")==0)
   {
      
      cp1.setColor(greenrange[0]);
      cp2.setColor(greenrange[1]);
      cp3.setColor(greenrange[2]);
      cp4.setColor(greenrange[3]);
      cp5.setColor(greenrange[4]);
    }
    else if(clrrg.compareTo("gray")==0)
    {
      cp1.setColor(grayrange[0]);
      cp2.setColor(grayrange[1]);
      cp3.setColor(grayrange[2]);
      cp4.setColor(grayrange[3]);
      cp5.setColor(grayrange[4]);
    }
    rcp.revalidate();
 }

}
   

public boolean showDialog( Geditor geditor)
{  ok=false;
   if(actlayer==null)
   GeditGlobal.showErrorDialog((JFrame)geditor, "No active Layer.");
   else if(attrnum==0)
      GeditGlobal.showErrorDialog((JFrame)geditor, 
      "No attributes are numbers.");
    else
     show();
     if(ok)//update the map relation
     {
   if(r1.getText().compareTo("")==0)//check if the range values are blank
      GeditGlobal.showErrorDialog((JFrame)geditor, "No selected attribute.");
   else {//check the range values
          double r1value=(new Double(r1.getText())).doubleValue();
          double r2value=(new Double(r2.getText())).doubleValue();
          double r3value=(new Double(r3.getText())).doubleValue();
          double r4value=(new Double(r4.getText())).doubleValue();
	   if (r1value<min)
	   {
	   GeditGlobal.showErrorDialog((JFrame)geditor,
	   "The first range value <min value in the data set.");
	   ok=false;}
	   else if(r4value>max)
	   {
	   GeditGlobal.showErrorDialog((JFrame)geditor,
	   "The last range value >max value in the data set.");
	   ok=false;}
           else if(onevalue)
	      {
	         if(!(r1value==r2value)&&(r2value==r3value)&&(r3value==r4value))
	         {
		 GeditGlobal.showErrorDialog((JFrame)geditor,
		 "The values of ranges are Wrong!");
		 ok=false;}
                 else
                   {
                      updMapColor();
                      updLegend();
                    }
	        }//not one value
		else  if(! (r1value<r2value && r2value<r3value && r3value<r4value))
	                 {
			 GeditGlobal.showErrorDialog((JFrame)geditor,
			 "The values of ranges are out of order.");
			 ok=false;}

                         else
                           {
                              updMapColor();
                               updLegend();
                            }
	  
         }
      }//end of if(ok)
      return(ok);
 }

//update the maprel with the selected range colors in  the dialog
private void updMapColor()
{
   double range1=(new Double(r1.getText())).doubleValue();
   double range2=(new Double(r2.getText())).doubleValue();
   double range3=(new Double(r3.getText())).doubleValue();
   double range4=(new Double(r4.getText())).doubleValue();
   int[] types=maprel.toTypes(maprel.domains);

   int pC=gdt.pC;
   int clr1=GeditColor.color2int(cp1.getColor());
   int clr2=GeditColor.color2int(cp2.getColor());
   int clr3=GeditColor.color2int(cp3.getColor());
   int clr4=GeditColor.color2int(cp4.getColor());
   int clr5=GeditColor.color2int(cp5.getColor());

   int pL=gdt.pL;
   for(int i=0;i<maprel.numtuples;i++)
    { 
    if(((String[])(maprel.data[pL]))[i].compareTo(actlayer)==0)
    {
    switch(types[pos])
   {case INTEGER:
       int curint=((int[])(maprel.data[pos]))[i];
       if(curint<range1)
        ((int[])(maprel.data[pC]))[i]=clr1;
       else if(curint<range2)
        ((int[])(maprel.data[pC]))[i]=clr2;
       else if(curint<range3)
        ((int[])(maprel.data[pC]))[i]=clr3;
       else if(curint<range4)
        ((int[])(maprel.data[pC]))[i]=clr4;
	else
        ((int[])(maprel.data[pC]))[i]=clr5;
	break;
    case DOUBLE:
       double curdbl=((double[])(maprel.data[pos]))[i];
       if(curdbl<range1)
        ((int[])(maprel.data[pC]))[i]=clr1;
       else if(curdbl<range2)
        ((int[])(maprel.data[pC]))[i]=clr2;
       else if(curdbl<range3)
        ((int[])(maprel.data[pC]))[i]=clr3;
       else if(curdbl<range4)
        ((int[])(maprel.data[pC]))[i]=clr4;
       else 
        ((int[])(maprel.data[pC]))[i]=clr5;
	break;
    case SHORT:
       short cursht=((short[])(maprel.data[pos]))[i];
       if(cursht<range1)
        ((int[])(maprel.data[pC]))[i]=clr1;
       else if(cursht<range2)
        ((int[])(maprel.data[pC]))[i]=clr2;
       else if(cursht<range3)
        ((int[])(maprel.data[pC]))[i]=clr3;
       else if(cursht<range4)
        ((int[])(maprel.data[pC]))[i]=clr4;
        else ((int[])(maprel.data[pC]))[i]=clr5;
	break;
    case LONG:
       long curlong=((long[])(maprel.data[pos]))[i];
       if(curlong<range1)
        ((int[])(maprel.data[pC]))[i]=clr1;
       else if(curlong<range2)
        ((int[])(maprel.data[pC]))[i]=clr2;
       else if(curlong<range3)
        ((int[])(maprel.data[pC]))[i]=clr3;
       else if(curlong<range4)
        ((int[])(maprel.data[pC]))[i]=clr4;
       else 
        ((int[])(maprel.data[pC]))[i]=clr5;
	break;
    case FLOAT:
        float curflt=((float[])(maprel.data[pos]))[i];
       if(curflt<range1)
        ((int[])(maprel.data[pC]))[i]=clr1;
       else if(curflt<range2)
        ((int[])(maprel.data[pC]))[i]=clr2;
       else if(curflt<range3)
        ((int[])(maprel.data[pC]))[i]=clr3;
       else if(curflt<range4)
        ((int[])(maprel.data[pC]))[i]=clr4;
       else
        ((int[])(maprel.data[pC]))[i]=clr5;
	break;
    default:
       break;
     }//end of switch
    }//end of if
  }//end of for     
    try{
    maprel.save();
    }catch(InterpretError ie){System.out.println("InterpretError");}
}

//update the legendhtb according to the range colors selected in the dialog
private void updLegend()
{ GeditLegend[] lgdarray=(GeditLegend[])gdt.legendhtb.get(actlayer);
  GeditLegend[] newlgdarray;
   int clr1=GeditColor.color2int(cp1.getColor());
   int clr2=GeditColor.color2int(cp2.getColor());
   int clr3=GeditColor.color2int(cp3.getColor());
   int clr4=GeditColor.color2int(cp4.getColor());
   int clr5=GeditColor.color2int(cp5.getColor());

  if(onevalue==true)
  { newlgdarray=new GeditLegend[1];
    newlgdarray[0]= new GeditLegend(actlayer,actlayer,clr5,lgdarray[0].symbol,classattr,r1.getText(),true,true,lgdarray[0].type);
   }
 else
 {
   newlgdarray=new GeditLegend[rgsize];
  

  newlgdarray[0]=new GeditLegend(actlayer,actlayer,clr1,lgdarray[0].symbol,classattr,min+".."+r1.getText(),true,true,lgdarray[0].type);
  newlgdarray[1]=new GeditLegend(actlayer,actlayer,clr2,lgdarray[0].symbol,classattr,r1.getText()+".."+r2.getText(),true,true,lgdarray[0].type);
  newlgdarray[2]=new GeditLegend(actlayer,actlayer,clr3,lgdarray[0].symbol,classattr,r2.getText()+".."+r3.getText(),true,true,lgdarray[0].type);
  newlgdarray[3]=new GeditLegend(actlayer,actlayer,clr4,lgdarray[0].symbol,classattr,r3.getText()+".."+r4.getText(),true,true,lgdarray[0].type);
  newlgdarray[4]=new GeditLegend(actlayer,actlayer,clr5,lgdarray[0].symbol,classattr,r4.getText()+".."+max,true,true,lgdarray[0].type);
  }
  gdt.legendhtb.remove(actlayer);
  gdt.legendhtb.put(actlayer,newlgdarray);
}

}//end of GeditRangeClass
