

import java.io.*;
import java.util.*;
import java.net.*;

public class JRelix implements Constants, TypeConstants
{

  public static void main(String args[])
  {
		//start Zongyan's addition -- July 2002
	 Socket Socket = null;
     PrintWriter outSocket = null;
     BufferedReader inSocket = null;
     String path,userName,userHome;
     String rspCode;
     int port;
	 boolean error_found = false;
	 ServerSocket s ;

	Interpreter interpreter = new Interpreter();
	Actualizer.interpreter = interpreter;

	Computation.interpreter = interpreter;

	EvalExpr.interpreter = interpreter;

//	Global.printHead();
	// the main loop of interpretation
//	interpreter.mainLoop(args);
// modified by Zongyan

		 if (args.length == 0 ){
     path =  System.getProperty("user.dir");
	 userName = System.getProperty("user.name");
	 //userHome = System.getProperty("user.home");  This can not deal with the directory links for unix system
	 try {
	 	userHome = path.substring(0, path.indexOf(userName)) + userName;
	 } catch( Exception e) 
	 {
		 //for Windows and single user. Actually, the userName and uerHome is not used for Windows.
		 userHome = System.getProperty("user.home"); 
	 }

	 // Initally the Golbal.start type equals 0;
	 // If Jrelix is launched in stand alone mode, start_type is still 0
	 // If Jrelix is launched in server mode succesfully, start_type is set to 1
	 // Unusally, if the current Jrelix can not using the port number allocated by the top level server to start 
	 //    a non top level server, then it asks the TL server to allocate a new port again, untill it success or 
	 //    there are  no more available ports
	 do{error_found = false;
		try{
            Socket = new Socket("localhost", 8888);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
            inSocket = new BufferedReader(new InputStreamReader(Socket.getInputStream()));
        } catch (IOException e) { 
			
			 if (path.endsWith("public_aldatp")){ //  top level aldatpServer
			 	Global.println("starting top level aldatp server");
			 	try{
			 		s = new ServerSocket(8888);
			 		new aldatpServer(s).start();
			 	} 
			 	catch(Exception se) {
				  Global.processThrowable(se);
			 	}
			 	Global.start_type = 1;
	         	aldatpUtility.checkport();
			 	Global.services.put(path + System.getProperty("file.separator"),"8888");
			 	Global.printHead();
	         	interpreter.mainLoop(args);
			 
			} else {
			
				Global.println("Starting stand alone JRelix."); // stand alone
				Global.start_type = 0;
				Global.printHead();
	        	interpreter.mainLoop(args);
			}
        }
		
        // start JRelix server
				
       	try{outSocket.println("CONTENT_TYPE : allocatePort ");			
       		outSocket.println(userName);			
       		outSocket.println(userHome);
			outSocket.println(path);			
			if (Debug)
				Global.println("waiting for TL server's response");			
			// receive response from top level server			
			StringTokenizer st = new StringTokenizer(inSocket.readLine(), ":");
			if (st.nextToken().indexOf("RESPONSE_CODE")<0 ) {
	             Global.println("401 Bad protocol" );
				 Global.println("Starting stand alone JRelix.");
				 Global.start_type = 0;
				 Global.printHead();
	             interpreter.mainLoop(args);
			}
	        rspCode = st.nextToken().trim();		
			if (rspCode.equals("OK")) { //  start server using allocated port
				port = Integer.parseInt(inSocket.readLine());	
		        
				// try to start server				
				try{
						s = new ServerSocket(port);				
				}catch (BindException e){
				   error_found = true;   //fail, try again
				   continue;				
				}
				
				 // start aldatpServer to listen the port, and invoke aldatpHandler threads
				if (path.indexOf("public_aldatp") <0 )				    
					Global.println("Starting protected lower level aldatp server using port:" + port);				
				else                     
					Global.println("Starting lower level aldatp server using port:" + port);
				new aldatpServer(s).start();
				Global.start_type = 1;
				try {
                   Socket = new Socket("localhost", 8888);
			       outSocket = new PrintWriter(Socket.getOutputStream(), true);
                   inSocket = new BufferedReader(new InputStreamReader(Socket.getInputStream()));
				} catch (IOException e) { 					
					Global.processThrowable(e);					
					return;
				}				
				// confirm port number, ask TL server to add it into it's dictionary				  
				outSocket.println("CONTENT_TYPE : confirmPort ");			      
				outSocket.println(path);
				outSocket.println(port);							
			} else if (rspCode.equals("NO available port")){				
				Global.println("Warning! " + rspCode);
				Global.println("Starting stand alone JRelix."); // stand alone
			    Global.start_type = 0;
			    Global.printHead();
	            interpreter.mainLoop(args);
			} else {				
					Global.println("Warning! " + rspCode); // perhaps one server is already started under this dir				
					return;
			}
        }
	    catch (IOException e){
			Global.processThrowable(e);
		}
		} while (error_found);
		Global.printHead();
	    interpreter.mainLoop(args);
	}
	else if (args[0].trim().equals("-SA")){
		Global.println("Starting stand alone JRelix."); // stand alone
		Global.printHead();
	    interpreter.mainLoop(args);
	}
	else {
		Global.println("Unknown argument"); // stand alone
	}
    // end Zongyan's addition
	
	
  } 
  
  
          
}
