

import java.io.*;
import java.util.*;
import java.net.*;

public class JRelixBack implements Constants, TypeConstants
{ 
  
  private static boolean Debug=false;
 
public static void main(String args[])
{   
	
	 Socket Socket = null;
     PrintWriter outSocket = null;
     BufferedReader inSocket = null;
     String path,userName,userHome;
     String rspCode;
     int port;
	 boolean error_found = false;
	 ServerSocket s ;
	 
	Interpreter interpreter = new Interpreter();
	Actualizer.interpreter = interpreter;
	Computation.interpreter = interpreter;
	EvalExpr.interpreter = interpreter;
	
    path =  System.getProperty("user.dir");
	userName = System.getProperty("user.name");
	//userHome = System.getProperty("user.home");
    userHome = path.substring(0, path.indexOf(userName)) + userName;
	  
		do{		error_found = false;
		try {
			
            Socket = new Socket("localhost", 8888);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
            inSocket = new BufferedReader(new InputStreamReader(Socket.getInputStream()));
        } catch (IOException e) { // 2) TL Server is not on
           // System.err.println("Couldn't get I/O for the connection to TOP level server");
			return;
		}
       	try{
			outSocket.println("CONTENT_TYPE : allocatePort ");			
			outSocket.println(userName);
			outSocket.println(userHome);
			outSocket.println(path);
						
			// receive response from top level server			
			StringTokenizer st = new StringTokenizer(inSocket.readLine(), ":");
			
			if (st.nextToken().indexOf("RESPONSE_CODE")<0 ) {
	             Global.println("401 Bad protocol" );
				 return;
			}
	        rspCode = st.nextToken().trim();		
			if (rspCode.equals("OK")) { // 3) start server using allocated port
				port = Integer.parseInt(inSocket.readLine());
				
				//start server				
				try{
				s = new ServerSocket(port);				
				}catch (BindException e){
			       error_found = true;
				   continue;				
				   }				
				
				// start aldatpServer to listen the port, and invoke aldatpHandler threads			
					Global.println("Starting none top level aldatp server using port:" + port);
				new aldatpServer(s).start();
				Global.start_type = 1;
				try {
                   Socket = new Socket("localhost", 8888);
			       outSocket = new PrintWriter(Socket.getOutputStream(), true);
                   inSocket = new BufferedReader(new InputStreamReader(Socket.getInputStream()));
				} catch (IOException e) { 					
					Global.processThrowable(e);					
					return;
				}
				// confirm port number, ask TL server to add it into it's dictionary				 
				 outSocket.println("CONTENT_TYPE : confirmPort ");			     
				  outSocket.println(path);
				  outSocket.println(port);			
				  } else {
				return;				
				//Global.println("No available port number now");				
				//Global.println("Aldatp server is not be started, please try later.");
			}			
        }
	    catch (IOException e){
			//Global.processThrowable(e);
			return;
		}
		} while (error_found);
}       

}