
/**
 * This class was generated by a SmartGuide.
 * 
 */
class JRelixInputStream extends java.io.InputStream {
	// the underlying InputStream
	protected java.io.InputStream in;
	// the StringBuffer holding input text
	protected StringBuffer sb = null;
	// flag indicating if the underlying InputStream is FileInputStream
	protected boolean isFileInputStream;

/**
 * JRelixInputStream constructor comment.
 * @param in java.io.InputStream
 */
protected JRelixInputStream(java.io.InputStream in) {
	this.in = in;
	sb = new StringBuffer(256);
	if (in instanceof java.io.FileInputStream) {
		isFileInputStream = true;
	}
}
/**
 * Returns the number of bytes that can be read from this input 
 * stream without blocking. 
 * <p>
 * The <code>available</code> method calls the <code>available</code> 
 * method of its underlying input stream and returns whatever value 
 * that method returns. 
 *
 * @return     the number of bytes that can be read from the input stream
 *             without blocking.
 * @exception  IOException  if an I/O error occurs.
 */
public int available() throws java.io.IOException {
	return in.available();
}
/**
 * Closes this input stream and releases any system resources 
 * associated with the stream. The <code>close</code> method
 * calls the <code>close</code> method of its underlying input stream. 
 *
 * @exception  IOException  if an I/O error occurs.
 */
public void close() throws java.io.IOException {
	in.close();
	sb = null;	// hint for GC
	isFileInputStream = false;
}
/**
 * This method returns the StringBuffer holding the input text.
 * @return java.lang.StringBuffer
 */
public StringBuffer getText() {
	return sb;
}
/**
 * Marks the current position in this input stream. A subsequent 
 * call to the <code>reset</code> method repositions this stream at 
 * the last marked position so that subsequent reads re-read the same bytes.
 * <p>
 * The <code>readlimit</code> argument tells this input stream to 
 * allow that many bytes to be read before the mark position gets 
 * invalidated. 
 * <p>
 * The <code>mark</code> method calls the <code>mark</code> method of 
 * its underlying input stream with the <code>readlimit</code> argument. 
 *
 * @param   readlimit   the maximum limit of bytes that can be read before
 *                      the mark position becomes invalid.
 */
public synchronized void mark(int readlimit) {
	in.mark(readlimit);
}
/**
 * Tests if this input stream supports the <code>mark</code> 
 * and <code>reset</code> methods. The <code>markSupported</code> 
 * method calls the <code>markSupported</code> method of its underlying 
 * input stream and returns whatever value that method returns. 
 *
 * @return  <code>true</code> if this stream type supports the
 *          <code>mark</code> and <code>reset</code> method;
 *          <code>false</code> otherwise.
 */
public boolean markSupported() {
	return in.markSupported();
}
/**
 * Reads the next byte of data from this input stream. The value 
 * byte is returned as an <code>int</code> in the range 
 * <code>0</code> to <code>255</code>. If no byte is available 
 * because the end of the stream has been reached, the value 
 * <code>-1</code> is returned. This method blocks until input data 
 * is available, the end of the stream is detected, or an exception 
 * is thrown. 
 * <p>
 * The <code>read</code> method calls the <code>read</code> method of 
 * its underlying input stream and returns whatever value that method returns. 
 *
 * @return     the next byte of data, or <code>-1</code> if the end of the
 *             stream is reached.
 * @exception  IOException  if an I/O error occurs.
 */
public int read() throws java.io.IOException {
	int n = in.read();
	if (n >= 0) {
		sb.append((char)n);
	}
	return n;
}
/**
 * Reads up to <code>byte.length</code> bytes of data from this 
 * input stream into an array of bytes. This method blocks until some 
 * input is available. 
 * <p>
 * The <code>read</code> method calls the <code>read</code> method of 
 * three arguments with the arguments <code>b</code>, <code>0</code>, and 
 * <code>b.length</code>, and returns whatever value that method returns.
 * <p>
 * Note that this method does not call the one-argument 
 * <code>read</code> method of its underlying stream with the single 
 * argument <code>b</code>.
 *
 * @param      b   the buffer into which the data is read.
 * @return     the total number of bytes read into the buffer, or
 *             <code>-1</code> if there is no more data because the end of
 *             the stream has been reached.
 * @exception  IOException  if an I/O error occurs.
 */
public int read(byte b[]) throws java.io.IOException {
	return read(b, 0, b.length);
}
/**
 * Reads up to <code>len</code> bytes of data from this input stream 
 * into an array of bytes. This method blocks until some input is 
 * available. 
 * <p>
 * The <code>read</code> method calls the <code>read</code> method of 
 * its underlying input stream with the same arguments and returns whatever 
 * value that method returns.
 *
 * @param      b     the buffer into which the data is read.
 * @param      off   the start offset of the data.
 * @param      len   the maximum number of bytes read.
 * @return     the total number of bytes read into the buffer, or
 *             <code>-1</code> if there is no more data because the end of
 *             the stream has been reached.
 * @exception  IOException  if an I/O error occurs.
 */
public int read(byte b[], int off, int len) throws java.io.IOException {
	int n = in.read(b, off, len);
	if (n > 0) {	// there is data read
		char c[] = new char[n];
		for (int i = 0; i < n; i++) {
			c[i] = (char)b[off + i];
		}
		sb.append(c);
	}
	return n;
}
/**
 * Repositions this stream to the position at the time the 
 * <code>mark</code> method was last called on this input stream. 
 * <p>
 * The <code>reset</code> method calls the <code>reset</code> method 
 * of its underlying input stream.
 * <p>
 * Stream marks are intended to be used in
 * situations where you need to read ahead a little to see what's in
 * the stream. Often this is most easily done by invoking some
 * general parser. If the stream is of the type handled by the
 * parse, it just chugs along happily. If the stream is not of
 * that type, the parser should toss an exception when it fails.
 * If this happens within readlimit bytes, it allows the outer
 * code to reset the stream and try another parser.
 *
 * @exception  IOException  if the stream has not been marked or if the
 *               mark has been invalidated.
 */
public synchronized void reset() throws java.io.IOException {
	in.reset();
}
/**
 * Reset the underlying input stream.
 * @param in java.io.InputStream
 */
public void resetIn(java.io.InputStream in) {
	this.in = in;
	sb = new StringBuffer(256);
	if (in instanceof java.io.FileInputStream) {
		isFileInputStream = true;
	}
}
/**
 * This method resets/clears the StringBuffer holding the input text.
 */
public void resetText() {
	sb = new StringBuffer(256);
}
/**
 * Skips over and discards <code>n</code> bytes of data from the 
 * input stream. The <code>skip</code> method may, for a variety of 
 * reasons, end up skipping over some smaller number of bytes, 
 * possibly <code>0</code>. The actual number of bytes skipped is 
 * returned. 
 * <p>
 * The <code>skip </code>method calls the <code>skip</code> method 
 * of its underlying input stream with the same argument, and returns 
 * whatever value that method does.
 *
 * @param      n   the number of bytes to be skipped.
 * @return     the actual number of bytes skipped.
 * @exception  IOException  if an I/O error occurs.
 */
public long skip(long n) throws java.io.IOException {
	return in.skip(n);
}
}