

/**
 * The maximum length of each data type.
 * 	  boolean:	6 (5 is ok, 6 looks better)
 * 	  short  :	6
 * 	  int    :	11
 * 	  long   :	20
 * 	  float  :	13
 * 	  double :	23
 * @author Biao Hao (bhao@cs.mcgill.ca)
 * @version 0.5, 07/04/1997, 06/14/1998
 */
import java.io.*;

public class PrettyPrint implements TypeConstants
{
  private String rule
	   = "----------------------------------------"
		 + "----------------------------------------"
		 + "----------------------------------------"
		 + "----------------------------------------";


public PrettyPrint() {
}
	public int lengthOfType(int type)
	{
		switch(type) {
			case BOOLEAN :
				return BOOL_LEN;
			case SHORT :
				return SHORT_LEN;
			case INTEGER :
				return INT_LEN;
			case LONG :
			case IDLIST :
			case COMP:			//added by Yi Zheng March 20, 2002
				return LONG_LEN;
			case NUMERIC :     // added by Youhua. Need to print 
			                   // number type.
            case UNIVERSAL :   //added by A. Rozenberg. Same as a string
			case ATTRIBUTE :
			case TYPE :              //added by Yu, June 20, 2004
			case UNION :		//added by Yu, June 30,2004
			case STRING :
			case TEXT :
			case STMT :
			case EXPR :
				return STRING_LEN;
			case FLOAT :
				return FLOAT_LEN;
			case DOUBLE :
				return DOUBLE_LEN;
		}
		return 0;
	}
	public void pprint(byte val)
	{
		pprint(val, BOOL_LEN);
	}
	// print boolean which is stored as byte
	public void pprint(byte val, int len)
	{
		String s;

		if (val == BOOL_DK) s = "dk";
		else if (val == BOOL_DC) s = "dc";
		else if (val == 0) s = "false";
		else if (val == 1) s = "true";
		else s = "ERROR";

		pprint(s, len);
	}
	public void pprint(double val)
	{
		pprint(val, DOUBLE_LEN);
	}
	public void pprint(double val, int len)
	{
		String s;

		if (val == DOUBLE_DK) s = "dk";
		else if (val == DOUBLE_DC) s = "dc";
		else s = Double.toString(val);

		pprint(s, len);
	}
	public void pprint(float val)
	{
		pprint(val, FLOAT_LEN);
	}
	public void pprint(float val, int len)
	{
		String s;

		if (val == FLOAT_DK) s = "dk";
		else if (val == FLOAT_DC) s = "dc";
		else s = Float.toString(val);

		pprint(s, len);
	}
	public void pprint(int val)
	{
		pprint(val, INT_LEN);
	}
	public void pprint(int val, int len)
	{
		String s;

		if (val == INT_DK) s = "dk";
		else if (val == INT_DC) s = "dc";
		else s = Integer.toString(val);

		pprint(s, len);
	}
	public void pprint(long val)
	{
		pprint(val, LONG_LEN);
	}
	public void pprint(long val, int len)
	{
		String s;

		if (val == LONG_DK) s = "dk";
		else if (val == LONG_DC) s = "dc";
		else s = Long.toString(val);

		pprint(s, len);
	}
	public void pprint(String val)
	{
		if (val==null) System.out.println("string is empty");
		pprint(val, STRING_LEN);
	}
	/*
	 *   The following procedure is added for printing
	 *   the number type attributes.
	 *    Youhua Chen,  November 15, 2000.
	 */
	 public void pprint(number val, int STRING_LEN)
         {
               pprint( val.toString(), STRING_LEN);
  	 }

	public void pprint(String val, int len)
	{
		int n = val.length();
		if (n < len) {
			print(val);
			for (int i = 0; i < len - n; i++)
				print(" ");
		} else {
			print(val.substring(0, len));
		}
	}
	public void pprint(short val)
	{
		pprint(val, SHORT_LEN);
	}
	public void pprint(short val, int len)
	{
		String s;

		if (val == SHORT_DK) s = "dk";
		else if (val == SHORT_DC) s = "dc";
		else s = Short.toString(val);

		pprint(s, len);
	}
	public void pprintRule()
	{
		pprintRule(80);
	}
	public void pprintRule(int len)
	{
		print(rule.substring(0, len));
	}
public void print(String val) {
  Global.print(val);
}
/**
 * This method was created by a SmartGuide.
 */
public void println() {
	Global.println("");
}
public void println(String val) {
  Global.println(val);
}
}
