
import java.util.*;
import java.io.*;	//added for cleanUp Yi Zheng March 27, 2002

// New Constants Since jRelixNS:
//    OP_ATTRIBUTE:      469;
//    case OP_UNIVERSAL: 476;

public class Utility implements Constants, TypeConstants
//public class Utility extends Utility76
{  

//debugging
private static boolean DEBUG=false;
   /**
	* Check if type is a numeric type.
	*/
//   private static boolean isNumeric(int type){ Yi Zheng May 3, 2002
	public static boolean isNumeric(int type){ 
	  switch(type){
	case SHORT:
	case INTEGER:
	case LONG:
	case FLOAT:
		 case DOUBLE:
		 case NUMERIC:
	  case UNIVERSAL:  //this is universal type: can be numeric or text //from Andrey
          case ATTRIBUTE: //Fan Guo  June 25, 2004
	  case TYPE:  //this is projection of universal type //from Yu, June 07,2004
	  case UNION: //June 30,2004 by Yu
	  case BOOLEAN:    // Was missing //from Andrey
	   return true;
		 default:
	   return false;
	  }
   }      

   /**
	* Check if type is of text type.
	*/
//   private static boolean isText(int type){ Yi Zheng May 3, 2002
	public static boolean isText(int type){
	  switch(type){          // START Since jRelixNS

	  case UNIVERSAL:
	  case TYPE:		//June 07, 2004 by Yu
	  case UNION:		//June 30, 2004 by Yu
	  case ATTRIBUTE:          // END Since jRelixNS
	case STRING:
	case TEXT:
	case STMT:
	case EXPR:
	   return true;
		 default: 
	   return false;
	  }
   }      

   // Since jRelix77: allow BOOLEAN/IDLIST
   /**
	* Check if type is of text type.
	*/
   private static boolean isBoolType(int type){
	  switch(type){
	  	// START Since JRelCaNu c.
	case DK:
	case DC:
// END Since JRelCaNu c.
	case ATTRIBUTE: //Fan Guo  June 25, 2004
	case BOOLEAN:
	case IDLIST:
	   return true;
		 default: 
	   return false;
	  }
   }      
   public static boolean isBoolOrIDListType(int type){
         return isBoolType(type);
   }
   // END Since jRelix77: allow BOOLEAN/IDLIST

   /**
	* Converse integer type to string type name.
	*/
   public static String type2String(int type){
	//System.out.println(type);
	  switch(type){                  // START Since jRelixNS

	         case UNIVERSAL:   return("universal");
	         case TYPE:   return("type");		//June 17,2004 by Yu
		 case ATTRIBUTE:   return("attribute");
		                  // END Since jRelixNS

		 case BOOLEAN:     return("boolean");
		 case SHORT:       return("short");
		 case INTEGER:     return("integer");
		 case LONG:        return("long");
		 case FLOAT:       return("float");
		 case DOUBLE:      return("double");
		 case NUMERIC:     return("number");
		 case STRING:      return("string");
		 case TEXT:        return("text");
		 case STMT:        return("statement");
		 case EXPR:        return("expression");
		 case IDLIST:      return("idlist");
//		 case COMP:        return("computation"); Yi Zheng May 3, 2002
		 case COMP:        return("comp");
		 case UNION:       return("union");     //Yu
		 case COMPUTATION: return("computation");
		 case RELATION:    return("relation");
		 case VIEW:        return("view");
		 case DK:          return("dk");
		 case DC:          return("dc");
                 case UNDEF:       return("undefined"); // Jiantao 2004
		 case SCALAR: return("scalar");
	//	 default: return("");
			 default: return("N/A"); //from Andrey
	  }
   }      
   /**
	* Return resulting type of operation (optype). If types mismatch,
	* throw an InterpretError exception.
	*/
   public static int typeCheck(int[] typeArray, int opcode)
		throws InterpretError{

	  int result;
	  
	  if(typeArray.length != 0)
	 result = typeArray[0];
	  else
	 throw new InterpretError("error: the size of typeArray is zero");

	  switch(opcode){
	//added by Yi Zheng July 4, 2002
	  case OP_NOP:	 
		for(int kk = 1; kk < typeArray.length; kk++)
		{
				if(typeArray[0] != typeArray[kk])
			throw new InterpretError("type mismatch for NOP operation");
		}
		result = typeArray[0];
		break;
	//end of addition July 4, 2002
	  case OP_MIN:
	  case OP_MAX:
	  case OP_PLUS:
	  case OP_MINUS:
	  case OP_MUL:
	  case OP_DIV:
	  case OP_MOD:
	  case OP_UPLUS:
	  case OP_UMINUS:
	  case OP_POW:
		 if(!isNumeric(typeArray[0]) && typeArray[0] != DK
			   && typeArray[0] != DC){
			   	//added by Yi Zheng July 9, 2002
			   	if(!isText(typeArray[0]) && typeArray[0] != DK
			   	 && typeArray[0] != DC)
			   	 //end of Yi's addition July 9, 2002
			throw new InterpretError("Utility.typeCheck: error: type mismatch.");
		 }
	for(int i = 1; i < typeArray.length; i++){
	   if(isNumeric(typeArray[i])){
		  result = Math.max(result, typeArray[i]);
			}else if(typeArray[i] == DK)
			   result = DK;
			else if(typeArray[i] == DC){
			   if(result == DC)  result = DC;
			   else if(result == DK) result = DK;
			}
			//addition by Yi Zheng July 9, 2002
			else if(isText(typeArray[i])) 
			{
				result = Math.max(result, typeArray[i]);
				
				}
				//end of addition July 9, 2002
				else{
		  throw new InterpretError("error: type mismatch.");
			}
		 }
		 break;
	  case OP_CAT:
	  case OP_SUBSTR:	//added by Yu, Oct 15,2004
//	  System.out.println("!!!typeArray[0]:"+typeArray[0]);
	if(!isText(typeArray[0])){
		  throw new InterpretError("error: type mismatch.");
		 }
	for(int i = 1; i < typeArray.length; i++){
//	  System.out.println("!!!typeArray[i]:"+i+";"+typeArray[i]);
	   if(isText(typeArray[i])){
		  result = STRING;
			}else{
		  throw new InterpretError("error: type mismatch.");
			}
		 }
	break;
	  case OP_EQ:
	  case OP_NEQ:
	  case OP_GT:
	  case OP_LT:
	  case OP_GE:
	  case OP_LE:
		 // must have two children.
	if(typeArray.length != 2){
			throw new InterpretError("error: too many arguments for comparison"
			   + " operator.");
		 }
		            // START Since jRelixNS //Andy, May 12, 2002
           //  Allow BOOLEAN/IDLIST compatibility.
	   if(Relation.isSigmaJoinImplemented != true)
           {
		 if((isNumeric(typeArray[0]) && (isNumeric(typeArray[1]) || typeArray[1] == DC))
	   || (isText(typeArray[0]) && isText(typeArray[1]))
	   || ((typeArray[0] == BOOLEAN) && (typeArray[1] == BOOLEAN)))
	   result = BOOLEAN;
		 else
	   throw new InterpretError("error: type mismatch.");
           }else{

		 if((isNumeric(typeArray[0]) && (isNumeric(typeArray[1]) || typeArray[1] == DC))
	   || (isText(typeArray[0]) && isText(typeArray[1]))
	   || (isBoolType(typeArray[0]) && isBoolType(typeArray[1])))
	   result = BOOLEAN;
		 else
		 
	   throw new InterpretError("error: type mismatch for comparison.");
           }
           // END Since jRelixNS
		 break; 
	  case OP_OR:
	  case OP_AND:
	  case OP_UNOT:
	for(int i = 0; i < typeArray.length; i++){
           // Since jRelix77: allow BOOLEAN/IDLIST
	 //  if(!isBoolType(typeArray[i])){
	   //if(typeArray[i] != BOOLEAN){
           // End Since jRelix77: allow BOOLEAN/IDLIST
                      // START Since jRelixNS
           //  Allow BOOLEAN/IDLIST compatibility.
	   if(Relation.isSigmaJoinImplemented != true) { //Andy, May 12, 2002
	     if(typeArray[i] != BOOLEAN)

		  throw new InterpretError("error: typeCheck:BOOLEAN type mismatch.");
           }else{
	       if(!isBoolType(typeArray[i]))
		  throw new InterpretError("error: typeCheck:BOOLEAN type mismatch.");
           }
           // END Since jRelixNS
		 }
		           // START Since JRelCaNu BUGFIX
          // All passed the isBoolType test.
          // This is needed to handle dc and dk literals in
          // the first position.
	  result = BOOLEAN;
          // END Since JRelCaNu BUGFIX

		 break;
	  case OP_IJOIN:
	  case OP_UJOIN:
	  case OP_SJOIN:
	  case OP_LJOIN:
	  case OP_RJOIN:
	  case OP_DLJOIN:
	  // case OP_DJOIN:
	  case OP_DRJOIN:
	  	  // START Since JRelixNS BUGFIX 2
          case OP_ICOMP  : 
          case OP_EQJOIN : 
          case OP_GTJOIN : 
          case OP_GEJOIN : 
          case OP_LTJOIN : 
          case OP_LEJOIN : 
          case OP_IEJOIN : 
          case OP_NOTICOMP  : 
          case OP_NOTEQJOIN : 
          case OP_NOTGTJOIN : 
          case OP_NOTGEJOIN : 
          case OP_NOTLTJOIN : 
          case OP_NOTLEJOIN : 
          case OP_NOTIEJOIN : 
	  // END Since JRelixNS BUGFIX 2

	for(int i = 0; i < typeArray.length; i++){
		                // BEGIN Since jRelixNS //Andy, May 12, 2002
                //  to avoid type mismatch error.
	        if(Relation.isSigmaJoinImplemented != true) {
			if((result == COMP && typeArray[i] == IDLIST)
			   || (result == IDLIST && typeArray[i] == COMP)
			   || (result == IDLIST && typeArray[i] == IDLIST))
				  result = IDLIST;
			else if(result == COMP && typeArray[i] == COMP)
			   result = COMP;
			else{
			   throw new InterpretError("typeCheck: type mismatch.");
			}
		 }else{

			if(((result == COMP || result == COMPUTATION) && typeArray[i] == IDLIST)
			   || (result == IDLIST && (typeArray[i] == COMP || typeArray[i] == COMPUTATION))
			   || (result == IDLIST && typeArray[i] == IDLIST))
				  result = IDLIST;
			else if((result == COMP || result == COMPUTATION) && (typeArray[i] == COMP || typeArray[i] == COMPUTATION))
			   result = COMP;
			 
			else if((result == RELATION && typeArray[i] == IDLIST)
			   || (result == IDLIST && typeArray[i] == RELATION)
			   || (result == IDLIST && typeArray[i] == IDLIST))
				  result = IDLIST;
			else if(result == RELATION && typeArray[i] ==
RELATION)
			   //result = RELATION;
			   result = IDLIST;
	
			else{
			   throw new InterpretError("typeCheck: type mismatch.");
			}
					   }
                   // END Since jRelixNS

		 }
		 break;
		 case OP_REDFUNCALL: //added by Yi Zheng July 8, 2002
		 break;
		           // START Since JRelCaNu a.1.
          // We should never get here, if OP_CAST is handled explicitely
          // by every calling method.
          case OP_CAST : 
		   throw new InterpretError("typeCheck: OP_CAST.");
          case OP_SUCC:  // Fan Guo Nov 19, 2004
                if(typeArray.length != 1){
                        throw new InterpretError("error: too many arguments for comparison"
                           + " operator.");
                 }
                break;
          case OP_TYPE : 
		   throw new InterpretError("typeCheck: OP_TYPE.");
          // END Since JRelCaNu a.1.

	  case OP_FUNCTION: 
	  ////////////////////SEE IMPLEMENTATION IN EvalExpr.java///////////////
	  default:
	 
		 System.out.println("typeCheck: to be implemented for " + opcode + " " + type2String(opcode) + ".");
	break;
	  }
//System.out.println("!!!Utility;result:"+result);
	  return result;
   }      
   /**
	* Converse type in SimpleNode to relix type.
	*/
   public static int typeConvert(int optype){
	  switch(optype){
	case OP_SHORT:    return SHORT;
	case OP_INTEGER:  return INTEGER;
	case OP_LONG:     return LONG;
	case OP_FLOAT:    return FLOAT;
	case OP_DOUBLE:   return DOUBLE;
	case OP_NUMERIC:  return NUMERIC;
	case OP_STRING:   return STRING;
	case OP_TEXT:     return TEXT;
	case OP_STMT:     return STMT;
	case OP_TRUE:     return BOOLEAN;
	case OP_FALSE:    return BOOLEAN;
	case OP_BOOLEAN:  return BOOLEAN;
	case OP_TUPLELIST: return IDLIST;
	case OP_DK:       return DK;
	case OP_DC:       return DC;
        case OP_UNDEF:    return UNDEF; // Jiantao 2004
	        // START Since jRelixNS
        case OP_TYPE:     return TYPE; // Fan Guo July 7, 2004
        case OP_IDLIST:   return IDLIST; // Fan Guo september 15, 2004
	case OP_ATTRIBUTE:    return ATTRIBUTE;
	case OP_Type:    return TYPE;		//Juen 07, 2004 by Yu
	case OP_UNIVERSAL:    return UNIVERSAL; 
	        // END Since jRelixNS

	default: 
	   System.out.println(
			 "error: DomTable typeConvert(): Unknown type: "+optype+".");
		return 0;
	  }
   }      
// START Since JRelixNS
// Used by Utility.dump(). Print descriptive string operators.
public static String jRelixConstToString(int opcode)
{
  switch (opcode) {
    case OP_EOF    : return("OP_EOF");//  -4;   //end of file
    case OP_IGNORE : return("OP_IGNORE");//  -3;   //ignore
    case OP_ERROR  : return("OP_ERROR");//  -1;   //error opcode
    case OP_COMMAND   : return("OP_COMMAND");//  0; //command
    case OP_HELP   : return("OP_HELP");//  1;
    case OP_QUIT   : return("OP_QUIT");//  2;
    case OP_INPUT  : return("OP_INPUT");//  3;
    case OP_DEBUG  : return("OP_DEBUG");//  4;
    case OP_BATCH  : return("OP_BATCH");//  5;
    case OP_EXPERT : return("OP_EXPERT");//  6;
    case OP_TIME   : return("OP_TIME");//  7;
    case OP_DELD   : return("OP_DELD");//  8;
    case OP_DELR   : return("OP_DELR");//  9;
    case OP_PR     : return("OP_PR/OP_SHIFT");//  10;
    case OP_SC     : return("OP_SC");//  19;
    case OP_SD     : return("OP_SD");//  11;
    case OP_SR     : return("OP_SR");//  12;
    case OP_SRD    : return("OP_SRD");//  13;
    case OP_PRINT  : return("OP_PRINT");//  14;
    case OP_SSD         : return("OP_SSD");//       15;
    case OP_SSR         : return("OP_SSR");//       16;
    case OP_TRACE : return("OP_TRACE");// 17;

   // *********** Statement ***********

   // Statement and its combination
    case OP_STATEMENT : return("OP_STATEMENT");//  100;  //statement
    case OP_SEQUENCE  : return("OP_SEQUENCE");//  101;
    case OP_PARALLEL  : return("OP_PARALLEL");//  102;
    case OP_CHOICE : return("OP_CHOICE");//  103;
    case OP_COMPCALL  : return("OP_COMPCALL");//       104;
    case OP_CONDITIONAL : return("OP_CONDITIONAL");//       105;
    case OP_FORLOOP     : return("OP_FORLOOP");//       106;
    case OP_WHILELOOP   : return("OP_WHILELOOP");//       107;
    case OP_EXIT   : return("OP_EXIT");//  108;
    case OP_DEADLOCK  : return("OP_DEADLOCK");//  109;
    case OP_EXEC   : return("OP_EXEC");//  110;
    case OP_STMTBLOCK : return("OP_STMTBLOCK");//  111;

   // Declaration statement
    case OP_DECLARATION  : return("OP_DECLARATION");//  140;  //declaration
    case OP_RELATION  : return("OP_RELATION");//  141;
    case OP_VIEW   : return("OP_VIEW");//  142;
    case OP_DOMAIN : return("OP_DOMAIN");//  143;
    case OP_LET    : return("OP_LET");//  144;
    case OP_COMPUTATION  : return("OP_COMPUTATION");//  145;

   // Assignment statement
    case OP_ASSIGNMENT   : return("OP_ASSIGNMENT");//  160;  //assignment
    case OP_ASSIGN : return("OP_ASSIGN");//  161;
    case OP_ASSIGNADD : return("OP_ASSIGNADD");//  162;

   // Update statement
    case OP_UPDATE : return("OP_UPDATE");//  180;  //update
    case OP_ADD    : return("OP_ADD");//  181;
    case OP_DELETE : return("OP_DELETE");//  182;
    case OP_CHANGE : return("OP_CHANGE");//  183;
    case OP_USING  : return("OP_USING");//  184;  //using
   
   
   //Gedit statement
    case OP_GEDIT : return("OP_GEDIT");//  190;   //Gedit
    case OP_CONTAINS : return("OP_CONTAINS");// 191;
    case OP_WITHIN : return("OP_WITHIN");// 192;
    case OP_CMPCONTAINS : return("OP_CMPCONTAINS");// 193;
    case OP_CMPWITHIN : return("OP_CMPWITHIN");// 194;
    case OP_INTERSECT : return("OP_INTERSECT");// 195;
    case OP_WITHINDIST : return("OP_WITHINDIST");// 196;


    case OP_INIT   : return("OP_INIT");//  200;  //init
    case OP_RCOPY  : return("OP_RCOPY");//  201;
    case OP_ISCOPY : return("OP_ISCOPY");//  202;

    case OP_CONSTANT  : return("OP_CONSTANT");//  210;  //constant
    case OP_TUPLELIST : return("OP_TUPLELIST");//  211;
    case OP_TUPLE  : return("OP_TUPLE");//  212;

    case OP_STMTLIST  : return("OP_STMTLIST");//  220;  //statement list

    case OP_IDENTIFIER   : return("OP_IDENTIFIER");//  230;  //identifier

    case OP_FILEPATH  : return("OP_FILEPATH");//  240;  //filepath


    case OP_BIOPERATOR   : return("OP_BIOPERATOR");//  300;  //binary operator
    case OP_JOINOPERATOR: return("OP_JOINOPERATOR");//   301;  //binary join operator
    case OP_UOPERATOR : return("OP_UOPERATOR");//  302;  //unary operator
    case OP_QTOPERATOR   : return("OP_QTOPERATOR");//  304;  //QT operator
    case OP_RED    : return("OP_RED");//  306;  //red
    case OP_EQUIV  : return("OP_EQUIV");//  308;  //equiv
    case OP_FUN    : return("OP_FUN");//  310;  //fun
    case OP_PAR    : return("OP_PAR");//  312;  //par

    case OP_OR     : return("OP_OR");//  320;
    case OP_AND    : return("OP_AND");//  321;
    case OP_SUBSTR : return("OP_SUBSTR");//  322;
    case OP_EQ     : return("OP_EQ");//  323;
    case OP_NEQ    : return("OP_NEQ");//  324;
    case OP_GT     : return("OP_GT");//  325;
    case OP_LT     : return("OP_LT");//  326;
    case OP_GE     : return("OP_GE");//  327;
    case OP_LE     : return("OP_LE");//  328;
    case OP_CAT    : return("OP_CAT");//  329;
    case OP_MIN    : return("OP_MIN");//  330;
    case OP_MAX    : return("OP_MAX");//  331;
    case OP_PLUS   : return("OP_PLUS");//  332;
    case OP_MINUS  : return("OP_MINUS");//  333;
    case OP_MUL    : return("OP_MUL");//  334;
    case OP_DIV    : return("OP_DIV");//  335;
    case OP_MOD    : return("OP_MOD");//  336;
    case OP_POW    : return("OP_POW");//  337;
    case OP_PRED   : return("OP_PRED");//  338;
    case OP_SUCC   : return("OP_SUCC");//  339;
    case OP_CAST   : return("OP_CAST");//  340;
    case OP_NOP    : return("OP_NOP");//  360;
    case OP_IJOIN  : return("OP_IJOIN");//  361;
    case OP_UJOIN  : return("OP_UJOIN");//  362;
    case OP_SJOIN   : return("OP_SJOIN");//   363;
    case OP_LJOIN   : return("OP_LJOIN");//   364;
    case OP_RJOIN   : return("OP_RJOIN");//   365;
    case OP_DJOIN   : return("OP_DJOIN");//   366; // DJOIN is DLJOIN
    case OP_DRJOIN  : return("OP_DRJOIN");//   367;
    case OP_ICOMP  : return("OP_ICOMP");//  380;
    case OP_EQJOIN : return("OP_EQJOIN");//  381;
    case OP_GTJOIN : return("OP_GTJOIN");//  382;
    case OP_GEJOIN : return("OP_GEJOIN");//  383;
    case OP_LTJOIN : return("OP_LTJOIN");//  384;
    case OP_LEJOIN : return("OP_LEJOIN");//  385;
    case OP_IEJOIN : return("OP_IEJOIN");//  386;
    case OP_NOTICOMP  : return("OP_NOTICOMP");//  390;
    case OP_NOTEQJOIN : return("OP_NOTEQJOIN");//  391;
    case OP_NOTGTJOIN : return("OP_NOTGTJOIN");//  392;
    case OP_NOTGEJOIN : return("OP_NOTGEJOIN");//  393;
    case OP_NOTLTJOIN : return("OP_NOTLTJOIN");//  394;
    case OP_NOTLEJOIN : return("OP_NOTLEJOIN");//  395;
    case OP_NOTIEJOIN : return("OP_NOTIEJOIN");//  396;

    case OP_UPLUS  : return("OP_UPLUS");//  400;
    case OP_UMINUS : return("OP_UMINUS");//  401;
    case OP_UNOT   : return("OP_UNOT");//  402;
    case OP_PICK   : return("OP_PICK");//  403;
    case OP_EVAL   : return("OP_EVAL");//  404;

    case OP_DOT    : return("OP_DOT");//  410;
    case OP_PERCENT   : return("OP_PERCENT");//  411;
    case OP_NUMBER : return("OP_NUMBER");//  412;

    case OP_PROJECTOR : return("OP_PROJECTOR");//  420;  //projector
    case OP_PROJECT   : return("OP_PROJECT");//  421;  //project
    case OP_TSELECT   : return("OP_TSELECT");//  422;  //TSelect
    case OP_SELECT : return("OP_SELECT");//  423;  //selector
    case OP_QSELECT   : return("OP_QSELECT");//  424;  //Qselector
    case OP_WHEREIN   : return("OP_WHEREIN");//  425;
    case OP_WHEREFROM : return("OP_WHEREFROM");//  426;
    case OP_WHENIN : return("OP_WHENIN");//  427;  //also for in
    case OP_WHENFROM  : return("OP_WHENFROM");//  428;  //also for from
    case OP_EDIT   : return("OP_EDIT");//  429;  //sub of selector
    case OP_ZORDER : return("OP_ZORDER");//  430;  //sub of selector

    case OP_TYPE   : return("OP_TYPE");//       450;   //type
    case OP_BOOLEAN   : return("OP_BOOLEAN");//       451;
    case OP_SHORT  : return("OP_SHORT");//       452;
    case OP_INTEGER   : return("OP_INTEGER");//       453;
    case OP_LONG   : return("OP_LONG");//       454;
    case OP_FLOAT  : return("OP_FLOAT");//       455;
    case OP_DOUBLE : return("OP_DOUBLE");//       456;
    case OP_NUMERIC : return("OP_NUMERIC");//457;
    case OP_STRING : return("OP_STRING");//       458;
    case OP_TEXT   : return("OP_TEXT");//       459;
    case OP_STMT   : return("OP_STMT");//       460;
    case OP_EXPR   : return("OP_EXPR");//       461;
    case OP_COMP   : return("OP_COMP");//       462;
    case OP_IDLIST : return("OP_IDLIST");//       463;

    case OP_LITERAL   : return("OP_LITERAL");//  470;  //literal
    case OP_NULL   : return("OP_NULL");//  471;
    case OP_DC     : return("OP_DC");//  472;
    case OP_DK     : return("OP_DK");//  473;
    case OP_TRUE   : return("OP_TRUE");//  474;
    case OP_FALSE  : return("OP_FALSE");//  475;
    case OP_UNDEF : return("OP_UNDEF");//  477; Jiantao 2004


    case OP_FUNCTION  : return("OP_FUNCTION");//  500;  //function
    case OP_ABS    : return("OP_ABS");//  501;
    case OP_SQRT   : return("OP_SQRT");//  502;
    case OP_SIN    : return("OP_SIN");//  503;
    case OP_ASIN   : return("OP_ASIN");//  504;
    case OP_COS    : return("OP_COS");//  505;
    case OP_ACOS   : return("OP_ACOS");//  506;
    case OP_TAN    : return("OP_TAN");//  507;
    case OP_ATAN   : return("OP_ATAN");//  508;
    case OP_SINH   : return("OP_SINH");//  509;
    case OP_COSH   : return("OP_COSH");//  510;
    case OP_TANH   : return("OP_TANH");//  511;
    case OP_LOG    : return("OP_LOG");//  512;
    case OP_LOG10  : return("OP_LOG10");//  513;
    case OP_ROUND  : return("OP_ROUND");//  514;
    case OP_CEIL   : return("OP_CEIL");//  515;
    case OP_FLOOR  : return("OP_FLOOR");//  516;
    case OP_ISKNOWN   : return("OP_ISKNOWN");//  517;
    case OP_CHR    : return("OP_CHR");//  518;
    case OP_ORD    : return("OP_ORD");//  519;

    case OP_QTLIST : return("OP_QTLIST");//  550;  //quantifier list
    case OP_QUANTIFIER   : return("OP_QUANTIFIER");//  552;  //quantifier

    case OP_ARRAY  : return("OP_ARRA");//  560;  //array
    case OP_INDEXLIST : return("OP_INDEXLIST");//  562;  //array index list

    case OP_RENAME: return("OP_RENAME");//  570;  //positional rename

    case OP_IFTHENELSE   : return("OP_IFTHENELSE");// 580;  //if-then-else-expr

    case OP_EXPRESSION : return("OP_EXPRESSION ");//  590;  //expression
    case OP_EXPRLIST  : return("OP_EXPRLIST");//  592;  //expression list


    case OP_PARALIST  : return("OP_PARALIST");//  600;  //("");//parameter list
    case OP_PARAMETER : return("OP_PARAMETER");//  602;  //parameter
    case OP_CALLPARALIST: return("OP_CALLPARALIST");//   610;  //call para list
    case OP_CALLPARA  : return("OP_CALLPARA");//  612;  //call para

    case OP_COMPNAME  : return("OP_COMPNAME");//  640;  //computation name
    case OP_COMPIDENTIFIER  : return("OP_COMPIDENTIFIER");//  641;  //identifier of computation
    case OP_EVENTNAME  : return("OP_EVENTNAME");//  642;  //event name
    case OP_UNDO  : return("OP_UNDO");//  644;  // undo the update event
    case OP_EVENTON  : return("OP_EVENTON");//  646;  // turn on the event
    case OP_EVENTOFF  : return("OP_EVENTOFF");//  648;  // turn off the event
    case OP_COMPBODY  : return("OP_COMPBODY");//  650;  //comp body
    case OP_COMPBLOCK : return("OP_COMPBLOCK");//  660;  //comp block
    case OP_COMPVARDECL  : return("OP_COMPVARDECL");//  670;  //comp var decl
    case OP_LOCALVARDECL: return("OP_LOCALVARDECL");//   672;  //local var decl
    case OP_STATEVARDECL: return("OP_STATEVARDECL");//   674;  //state var decl
    case OP_COMPINIT  : return("OP_COMPINIT");//  680;  //comp init
    case OP_VARINIT   : return("OP_VARINIT");//  682;  //var init
    case OP_PREFIX  : return("OP_PREFIX");//  690;  //prefix
    case OP_POST  : return("OP_POST");//  692;  //pre prefix
    case OP_PRE  : return("OP_PRE");//  694;  //post prefix
    case OP_ACTION  : return("OP_ACTION");//  696;  //action
    case OP_ATTRIBUTE: return("OP_ATTRIBUTE");//  469;
    case OP_UNIVERSAL: return("OP_UNIVERSAL");//  476;
    case OP_Type: return("OP_Type");//  481;		//June 07,2004 by Yu; domain type type.
	case OP_QUOTE: return ("OP_QUOTE"); //406
	case OP_TRANSPOSE: return ("OP_TRANSPOSE"); //408
	case OP_REDFUNCALL: return ("OP_REDFUNCALL"); //701
    default: return("***Utility.jRelixConstToString:OP_UNKNOWN***");
  }
}

  // Extends SimpleNode.dump() to dump text operator instead of number operators
  public static void dump(SimpleNode node, String prefix) {
	System.out.println(node.toString(prefix) + ":" + Utility.jRelixConstToString(node.type) + ":" + Utility.jRelixConstToString(node.opcode) +
	":" + node.name + ":" + node.bits);
	if (node.children != null) {
	  for (java.util.Enumeration e = node.children.elements();
	  e.hasMoreElements();) {
   SimpleNode n = (SimpleNode)e.nextElement();
   dump(n,prefix + " ");
	  }
	}
  }    
// END Since JRelixNS

	/**
	 * method for removing temp files at exit
	 * @author Yi Zheng March 27, 2002
	 */
	 public static void cleanUp(String fpattern)
	 {
	 	File dir = new File(".");
	 	String[] files = dir.list();
	 	for (int i = 0; i < files.length; i++)
	 	{
	 		File f = new File(files[i]);
	 		if(f.isFile() && files[i].startsWith(fpattern))
	 			f.delete();
	 	}
	 }
	 
	 /**
	  * used by Actualizer
	  * @author Yi Zheng July 2, 2002
	  */
	 public static boolean isPrimitiveType(int opcode)
	 {
	 	switch(opcode)
	 	{
	 		case OP_OR:
	 		case OP_AND:
	 		case OP_MIN:
	 		case OP_MAX:
	 		case OP_PLUS:
	 		case OP_MUL:
	 			return true;
	 		default:
	 			return false;
	 	}
	 }
	 /**
	  * @author Yu Nov 8,2004
	 */
	 public static boolean isPrimitive(String type)
	 {
		if (type.equals("string")||(type.equals("integer"))||(type.equals("short"))|| (type.equals("long"))|| (type.equals("double"))|| (type.equals("float"))|| (type.equals("boolean"))|| (type.equals("numeric")) )	 	
	 			return true;
	 	else
	 			return false;
	 	
	 }
	 
	     // START Since JRelCaNu a.1.
    public static boolean domsCastCompatible(int typeLHS, int typeRHS) {
//	System.out.println("typeLHS:"+typeLHS+"typeRHS:"+typeRHS);
        switch (typeLHS) {
//	System.out.println("typeLHS:"+typeLHS+"typeRHS:"+typeRHS);
        case UNIVERSAL: 
        //case ATTRIBUTE:  // Commented out on September 14, 2004
            return false;
        case ATTRIBUTE:  // moved here on September 14, 2004 by Fan
                return CastToAttr.domCompatible(typeRHS);

        case BOOLEAN:
            return CastToBoolByte.domCompatible(typeRHS);

        case SHORT:
            return CastToShort.domCompatible(typeRHS);

        case INTEGER:
            return CastToInt.domCompatible(typeRHS);

        case LONG:
            return CastToLong.domCompatible(typeRHS);

        case FLOAT:
            return CastToFloat.domCompatible(typeRHS);

        case DOUBLE:
            return CastToDouble.domCompatible(typeRHS);

        case NUMERIC:
            return CastToNum.domCompatible(typeRHS);

        case STRING:
            return CastToStrn.domCompatible(typeRHS);

        case TEXT:
        case STMT:
        case EXPR:
        case IDLIST:
        case COMP:
        case COMPUTATION:
        case RELATION:
        case VIEW:
        case DK:
        case DC:
            return false;
        }
        return false;
    }
    // END Since JRelCaNu a.1.
    
    /******************** start Fan's new supporting methods ***********************/  
    /**
	* Check if a atring is a type.
	*/
   public static boolean IsaType(String s){  // September 2004 Fan
	  Vector type = new Vector();
	  type.add("attribute");
	  type.add("attr");
	  type.add("universal");
	  type.add("anytype");
	  type.add("univ");
	  type.add("boolean");
	  type.add("bool");
	  type.add("short");
	  type.add("integer");
	  type.add("intg");
	  type.add("long");
	  type.add("float");
	  type.add("double");
	  type.add("number");
	  type.add("numeric");
	  type.add("string");
	  type.add("strg");
	  type.add("text");
	  type.add("statement");
	  type.add("stmt");
	  type.add("expression");
	  type.add("expr");
	  type.add("idlist");
	  type.add("comp");
	  type.add("computation");
	  type.add("relation");
	  type.add("view");
	  type.add("dk");
	  type.add("dc");
	  type.add("type"); 	
	  type.add("compound"); 
	  
	  String[] typeArray = new String[type.size()];
	  type.copyInto(typeArray);
	  String str = s.toLowerCase();
	  for (int i=0;i<typeArray.length; i++) 
	  	if(typeArray[i].equals(str)) 
	  		return true;
	  return false;	   	
   }      
   /**
	* Converse type in relix to SimpleNode type.
	*/
 public static int typeConvertToSimpleNode(int optype){ // September 15, 2004 Fan Guo
	  switch(optype){
	//case SHORT:    return OP_SHORT;
	case INTEGER:  return OP_INTEGER;
	case LONG:     return OP_LONG;
	case FLOAT:    return OP_FLOAT;
	case DOUBLE:   return OP_DOUBLE;
	case NUMERIC:  return OP_NUMERIC;
	case STRING:   return OP_STRING;
	case TEXT:     return OP_TEXT;
	case STMT:     return OP_STMT;
	//case TRUE:     return OP_BOOLEAN;
	case FALSE:    return OP_BOOLEAN;
	//case BOOLEAN:  return OP_BOOLEAN;
	//case TUPLELIST: return OP_IDLIST;
	case IDLIST:	return OP_IDLIST;
	case DK:       return OP_DK;
	case DC:       return OP_DC;
	case TYPE: 	  return OP_TYPE; // Fan Guo July 7, 2004
	        // START Since jRelixNS

	case ATTRIBUTE:    return OP_ATTRIBUTE;
	case UNIVERSAL:    return OP_UNIVERSAL; 
	        // END Since jRelixNS

	default: 
	   System.out.println(
			 "error: DomTable typeConvert(): Unknown type: "+optype+".");
		return 0;
	  }
 }
   /******************** end of Fan's new supporting methods ***********************/

    // Jiantao 2004
        public static void dumpxML(SimpleNode node, String prefix)
        {       System.out.println(node.toString(prefix) + " - info=" + node.info);
                if(node.attrs != null)
                {       System.out.print(node.toString(prefix).replaceAll("\\S", " ") + " - attrs: ");
                        for(Enumeration e = node.attrs.keys(); e.hasMoreElements();)
                        {       String key = (String)e.nextElement();
                                System.out.print(" " + key + "=" + node.attrs.get(key) + ",");
                        }
                        System.out.println();
                }
        if (node.children != null) {
          for (java.util.Enumeration e = node.children.elements();
          e.hasMoreElements();) {
   SimpleNode n = (SimpleNode)e.nextElement();
   dumpxML(n,prefix + "  ");
          }
        }
  }
   

}
