/**
 * Aldatp Client
 *
 * @author Zongyan Wang
 *
 * July 22 2002 --
 *
 * 
 */
import java.lang.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import java.net.*;


public class aldatpClient implements Constants, TypeConstants
{
  public static Environment env;   
  public static Relation rel;
  public static String rspCode;
  private static Hashtable idset;
  private static String host;
  private static int port;
  private static  String fileSeparator;
  
   public static void request( SimpleNode node ,Environment env) throws InterpretError
  {    
     String fromServer, contentType, contentLen;
     Socket Socket = null;
     PrintWriter outSocket = null;
     DataInputStream inSocket = null;
     String URL;
     String record;
	
	   
	   //inital phase: dump parser tree, init socket, send request
	  
	   rel = null;
	   
	   //get hostname ane port number
	   init(node.url);
	   URL = node.url;
	 
	   // send parser tree
	    node.url = null;
        try {
            Socket = new Socket(host, port);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
			inSocket= new DataInputStream(Socket.getInputStream());
        } catch (UnknownHostException e) {
			rspCode = "503 service temporarily unavailable ";
            Global.processThrowable(e);
			return;
           
        } catch (IOException e) {
			rspCode = "503 service temporarily unavailable ";
			Global.processThrowable(e);
			return;
        }
		
		try{			
			outSocket.println("CONTENT_TYPE :ParserTree");			
			node.dump(outSocket);
			node.url = URL;			
			outSocket.println("END");
        }
	    catch (IOException e){
			rspCode = "301 communication error ";
		    Global.processThrowable(e);
			return;
		}
		
		// wait and receive response from server
		
		
		try{
			 fromServer = inSocket.readLine();
			 if (fromServer.indexOf("CONTENT_TYPE: errorMsg")>=0 ){ // catch an error
				  while ((fromServer = inSocket.readLine()) != null) {
			       if (fromServer.equals( "END" )) break;
				   Global.println(fromServer);
               }
			   fromServer = inSocket.readLine();  
			 }
			if (fromServer.indexOf("RESPONSE_CODE")<0 )
	             aldatpError("should start with RESPONSE_CODE" );// aldatpUssage(); introduce aldatp 
			rspCode = fromServer.substring(fromServer.indexOf(":")+1);
			
			StringTokenizer st = new StringTokenizer(inSocket.readLine(), ":");
			if (st.nextToken().indexOf("CONTENT_TYPE")<0 )
	             aldatpError("should start with CONTENT_TYPE" );
	        contentType = st.nextToken();
			 
			if ( contentType.equals("Rel")){
				
				rel = buildRel(inSocket,env);
			}
			outSocket.close();
            inSocket.close();
            Socket.close();
		}
		 catch (IOException e) {
			rspCode = "301 communication error ";
			Global.processThrowable(e);
			return;
        }
		
   }  
   
   
    public static void putRel( String rname, String lname,String URL,Environment env ) 
    throws InterpretError
   {  	     Socket Socket = null;
		 PrintWriter outSocket = null;
         DataInputStream inSocket = null;		
		 		 init(URL) ;
		 try {
            Socket = new Socket(host, port);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
			inSocket= new DataInputStream(Socket.getInputStream());
           
        } catch (UnknownHostException e) {
			throw new InterpretError("services temporarily unavailable");
           
        } catch (IOException e) {
			throw new InterpretError("services temporarily unavailable");
        }		 
		// send relation 	   
	   Relation rel = env.lookupRel(rname,false);
	   outSocket.println("CONTENT_TYPE : putRel");
	   outSocket.println(lname);
	   if(Debug) System.out.println("put " + rel.name + " to " +lname);	   
	   aldatpUtility.outputRel(null,rel,outSocket,env);
	   
		
   }
     public static String getRelName(String URL,Environment env ) throws InterpretError
   {  	     Socket Socket = null;
		 PrintWriter outSocket = null;
         DataInputStream inSocket = null;		 
         String name = null;
		 		 init(URL);
		 try {
            Socket = new Socket(host, port);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
			inSocket= new DataInputStream(Socket.getInputStream());
           
        } catch (UnknownHostException e) {
			 throw new InterpretError("services temporarily unavailable");
        } catch (IOException e) {
			  throw new InterpretError("services temporarily unavailable");
        }		 
		// send relation 	   
	   try {
	     outSocket.println("CONTENT_TYPE : getRelName");	     
	     name =  inSocket.readLine();
	   } catch (IOException e) {
		 rspCode = "503 service temporarily unavailable ";
		 Global.processThrowable(e);
	   }
	   return name;
   }
   
   public static void init (String URL) throws InterpretError   {
	 String fromServer;
     Socket Socket = null;
     PrintWriter outSocket = null;
     DataInputStream inSocket = null;
     String nurl = URL;
	 String type;
     int pos,nextpos,c; 
	 
	   String path = System.getProperty("user.dir");
	   
	  
	   if( URL.indexOf("aldatProtect://") >= 0 ){ //stand alone protected server
		    pos = URL.indexOf("aldatProtect://");
		    nextpos = URL.indexOf("/",pos+15);
	      host = URL.substring(pos+15, nextpos);
		  if (host.equals("localhost")) host = aldatpUtility.getHostname();
		  port = 8888;
		  nurl = URL.substring(nextpos+1) + System.getProperty("file.separator");
		  type = "enquireProtectedPort";
	   }
	   
	   else { //server under public directory
	   pos = URL.indexOf("aldatp://");
	   if (pos >=0 ) { //remote & local up
	      nextpos = URL.indexOf("/",pos+9);
	      host = URL.substring(pos+9, nextpos);
		  if (host.equals("localhost")) host = aldatpUtility.getHostname();
		  port = 8888;
		  nurl = URL.substring(nextpos+1);
		  type = "enquireRemotePort";
	   } 
	   else { //local down
		   host = "localhost";
		   port = 8888;
		   pos = URL.indexOf("aldatp:");
		   if (pos >=0 ) nurl = URL.substring(pos+7);
		   nurl = path + System.getProperty("file.separator") + nurl;
		   type = "enquireLocalPort";
		   }
	   }
	   
	   //enquire the server port number
		   
		   try {
            Socket = new Socket(host, port);
			outSocket = new PrintWriter(Socket.getOutputStream(), true);
			inSocket= new DataInputStream(Socket.getInputStream());
        } catch (UnknownHostException e) {
			  throw new InterpretError("services temporarily unavailable");
        } catch (IOException e) {
			  throw new InterpretError("services temporarily unavailable");
        }
		try{
			outSocket.println("CONTENT_TYPE :" + type);			
			outSocket.println( nurl);
			fromServer = inSocket.readLine();
			if (fromServer.indexOf("RESPONSE_CODE")<0 )
	             aldatpError("should start with RESPONSE_CODE" );// aldatpUssage(); introduce aldatp 
			rspCode = fromServer.substring(fromServer.indexOf(":")+1).trim();
			
			
			if ( rspCode.equals("OK") || rspCode.equals("start server")){
			     port = Integer.parseInt(inSocket.readLine().trim());		    	
			      if (rspCode.equals("start server"))
		             Global.aldatp_list.push(host + "|" + port );
			}			
			else{			  
					 throw new InterpretError("services temporarily unavailable");
			}				
        }
	    catch (IOException e){
			  throw new InterpretError("services temporarily unavailable");
		}
		   }
      public static Relation buildRel(DataInputStream inSocket,Environment env) throws InterpretError   
      {	   StringTokenizer st;	   String fromServer;
	   int pos;
	   
	   Relation relation = new Relation(env);
	   idset = new Hashtable();
	   try {	 
	            Interpreter interpreter = new Interpreter();
				String tmpname = interpreter.nextTempName();
				st = new StringTokenizer(inSocket.readLine(), "|");
			    String name = st.nextToken();
				int rvc =  Integer.parseInt(st.nextToken());
				
				
				relation.name = tmpname;
				relation.rvc = rvc;
				relation.numtuples = Integer.parseInt(st.nextToken());
				relation.numattrs = Integer.parseInt(st.nextToken());
				relation.numsortattrs = Integer.parseInt(st.nextToken());
				relation.domains = new Domain[relation.numattrs];
				
				
				for (int i = 0; i < relation.numattrs; i++){
					if(Debug) System.out.println( "i" + i +"/" + relation.numattrs);
					Domain domain = buildDomain(inSocket,env);
					
					Domain oldD = env.lookupDom(domain.name,true);
					if ( oldD == null || oldD.numref == 0){
						env.domtable.addDom(domain);
						relation.domains[i] = domain;
					}
					else {
						if (domain.type != oldD.type){ //idlist?
							rspCode = " Conflict domain : " + domain.name + " is being used as " + Utility.type2String(oldD.type);
						    System.err.println(rspCode);
							return null;
						}
					relation.domains[i] = oldD;
					}
				
				}
				
			  if(rvc == 17) { //comp
			  File outputFile = new File("_tmp_aldatp_tmpFile.txt");
              FileOutputStream os = new FileOutputStream(outputFile);
              PrintWriter outFile = new PrintWriter(os);
			  
		      while ((fromServer = inSocket.readLine()) != null) {
			       if (fromServer.equals( "END" )) break;
				   outFile.println(fromServer);
				    if(Debug) {System.out.println(fromServer ); }
               }
			  outFile.close();
			  relation.tree = aldatpUtility.getRootNode();
			  }
			  
			
			  File outputFile = new File("_tmp_aldatp_tmp");
              FileOutputStream os = new FileOutputStream(outputFile);
              PrintWriter outFile = new PrintWriter(os);
			  
			  if(idset.isEmpty()){
				  while ((fromServer = inSocket.readLine()) != null) {
			       if (fromServer.equals( "END" )) break;
				   outFile.println(fromServer);
                  }
			  }
			  else { //replace with the new surrogate allocated
		         while ((fromServer = inSocket.readLine()) != null) {
				   int init = 0 ,j = 0;
	               String newString =null ,tmp = null;
				   
			       if (fromServer.equals( "END" )) break;
				   
				   byte[] b = fromServer.getBytes();
				   for (pos=0; pos< b.length;pos++){
					   if (b[pos] == 6) {
						   tmp = fromServer.substring(init,pos);
						   init = pos+1;
						   if (relation.domains[j].type == IDLIST){
							    if(idset.containsKey(tmp)){
					            tmp = idset.get(tmp).toString();
				                } else {
					            rspCode = "Surrogate error";
					             throw new InterpretError("Surroget error");
				               }
						   }
						   j++;
						   outFile.print(tmp + fromServer.substring(pos,pos+1));
					   }
					   
				   }
				   if(init < pos){
					   newString = fromServer.substring(init,pos);							
				       outFile.println(newString);
				   }
                 }
			  }
			  outFile.close();
			  if ( rvc == 17) 
				  aldatpUtility.copyfile("_tmp_aldatp_tmp",relation.name+".comp");
			  else
				  Global. filterFile("_tmp_aldatp_tmp", relation.name);			
	   }
	    catch (IOException e){
		   rspCode = "shipping relation error";
		   Global.processThrowable(e);
		}
	   return relation;   }   
	public static Domain buildDomain(DataInputStream inSocket,Environment env) throws InterpretError	{									    StringTokenizer st;	    String fromServer,Nid,Oid;
		Vector domlist = new Vector();
		Domain[] domarry = null;
	    Domain domain = new Domain();
		Relation relation = new Relation(env);
		Domain[] domsr = null, domsl = null;
		Relation  rl = null;
		int pos;
		
		
		try {	
		Interpreter interpreter = new Interpreter();
		st = new StringTokenizer(inSocket.readLine(), "|");
		String name =  st.nextToken();
	    int type = Integer.parseInt(st.nextToken());
		if(Debug) System.out.println("name:" +name);
		if(Debug) System.out.println("type:" +type);
		
		if(type == IDLIST & !name.equals(".id")){
				st = new StringTokenizer(inSocket.readLine(), "|");
			    String relname = st.nextToken();
				
			    relation.name = interpreter.nextTempName();
				relation.rvc =  Integer.parseInt(st.nextToken());
				relation.numtuples = Integer.parseInt(st.nextToken());
				relation.numattrs = Integer.parseInt(st.nextToken());
				relation.numsortattrs = Integer.parseInt(st.nextToken());
				
				relation.domains = new Domain[relation.numattrs];
				for (int i = 0; i < relation.numattrs; i++){
					relation.domains[i] = buildDomain(inSocket,env);
					if(!relation.domains[i].name.equals(".id")) domlist.addElement(relation.domains[i]);
				}
			   
				
			domarry= new Domain[domlist.size()];
			domlist.copyInto(domarry);
			if (domarry == null)
				domarry = new Domain[0];
			
			
			 Domain oldD = env.lookupDom(name, true);
			 if(oldD == null || oldD.numref == 0){			 
				 // domain = new Domain(name, IDLIST, domarry, env, relation.numattrs);
				 if(Debug) System.out.println(" add new idlist domain");
				 domain = new Domain(name, IDLIST, domarry, env);
				 env.domtable.addDom(domain);
	         }else {
			    if (oldD.type != type){ //idlist
			 	  rspCode = " Conflict domain : " + domain.name + " is being used as " + Utility.type2String(oldD.type);
				  throw new InterpretError(rspCode);
		        }
			    domain = oldD;
	    	}
			 
			 
			 // ship data file
			
			  File outputFile = new File("_tmp_aldatp_tmp");
                FileOutputStream os = new FileOutputStream(outputFile);
                PrintWriter outFile = new PrintWriter(os);
		        while ((fromServer = inSocket.readLine()) != null) {
				if(Debug)	System.out.println(fromServer);
			       if (fromServer.equals( "END" )) break;
				   // assign new surrogate
				   byte[] b = fromServer.getBytes();
				   for (pos=0; pos< b.length;pos++){
					   if (b[pos] == 6) break;
				   }
				   Oid = fromServer.substring(0,pos);
				   if(idset.containsKey(Oid)){
					   Nid = idset.get(Oid).toString();
				   } else {
				   Nid = Long.toString(Surrogate.next());
				   idset.put(Oid,Nid);
				   }
				 // outFile.println(Nid + fromServer.substring(pos));
				   
				   outFile.print(Nid + fromServer.substring(pos,pos+1));
				   int j=1;
				   int init = pos +1;
				   b = fromServer.getBytes();
				   for (pos=init; pos< b.length;pos++){
					   if (b[pos] == 6) {
						   String tmp = fromServer.substring(init,pos);
						   init = pos+1;
						   if (relation.domains[j].type == IDLIST){
							    if(idset.containsKey(tmp)){
					            tmp = idset.get(tmp).toString();
				                } else {
					            rspCode = "Surrogate error";
					             throw new InterpretError("Surroget error");
				               }
						   }
						   j++;
						   outFile.print(tmp + fromServer.substring(pos,pos+1));
					   }
					   
				   }
				   if(init < pos){
					   String newString = fromServer.substring(init,pos);							
				       outFile.println(newString);
				   }
				   
				   
				   
				   
				   
               }
			   outFile.close();			   
			   Global. filterFile("_tmp_aldatp_tmp", relation.name);
			   
			 // add data file to env
			  
			   env.put (relation);
			   if(Debug) System.out.println("relname:" + relname);
			   rl = env.lookupRel(relname, true);
			   if (rl == null) 
				   env.put(relation.assign(domsr, relname, domsl));
			   else  
	               relation.assignAdd(domsr, rl, domsl);
			   env.removeRel(relation.name, true);
			 
			  
		}else { //regular domain ,e.g : doamin a string
		    domain.name =  name;
	        domain.type = type;		    //check 			
	        if(Debug) System.out.println(" lookup domian:" + domain.name);
		    Domain oldD = env.lookupDom(domain.name,true);
		    if ( oldD == null || oldD.numref == 0){
			   env.domtable.addDom(domain);
		    }
		    else {
			   if (domain.type != oldD.type){ 
			     	rspCode = " Conflict domain : " + domain.name + " is being used as " + Utility.type2String(oldD.type);
				    throw new InterpretError(rspCode);
		        }
			   domain = oldD;
		    }	  
	 	} // end of regular domain
	  }
	  catch (IOException e){
		 rspCode = "shipping relation error";
		 Global.processThrowable(e);
	  }	
	  if(Debug)	System.out.println("domain name:" + domain.name);		  
	  return domain;
	}  
    public static void dump( SimpleNode node ) 
  {  
	   try{
		   File outputFile = new File("testdumptree.txt");
           FileOutputStream os = new FileOutputStream(outputFile);
           PrintWriter outFile = new PrintWriter(os);		   
           if (node.type == OP_ALDATP) {
               SimpleNode nd = (SimpleNode) node.jjtGetChild(0);              
                nd.dump( outFile );			
           } else				
           	node.dump(outFile);
            outFile.close(); 
		   
	   }
	   catch (IOException e){
		   Global.processThrowable(e);
		}
	  
   }  
	 private static void aldatpError(String msg)
  { 
	rspCode = "301 bad protocol " + msg;
	return;	 
  } 
	 
	 
	
}