import java.lang.*;
class number
{
   public final int MaxDigNum = 10000; //8000; default to 10000 since allow exponent field up to 4 digits
   public static int precision = 30;
   public int expo;
   public char sign;
   public byte[] fraction;
   public int fractionLength;
   public boolean iszero = false;

  /**********************************************************************
   *Constructors:
   *	number(String theNumber)
   *	number(char s, byte[] f, int e)
   *
   *	Note:	CONSTRUCTOR 1
   *                the number is formatted in the form +****+####, where the
   *		    **** is the exponent field, with maximum 4 digit length
   *		    #### is the fraction field, where the decimal point goes
   *		    right in front of the first #. e.g./ +003+9 = 900
   *
   *		CONSTRUCTOR 2
   *		    s = sign of the number
   *		    f = byte array of fraction
   *		    e = exponent
   *
   *            DK/DC: the current NUMERIC_DK and NUMERIC_DC is set to the
   *                   same as the STRING_DK and STRING_DC, hence, the
   *                   strings "\u0000dk" and "\u0000dc" are the only
   *                   non-digit strings the constructor will accept
   *
   *	ALL NUMBERS ARE NORMALIZED AT CONSTRUCTION
   **********************************************************************/
    public number( String theNumber ) throws NumberFormatException
    {

	//  If this number string is passed here from JRelix, the '"'
	//	  and the N must be removed.
	if(theNumber == null){
	    theNumber = "+000+0";
	}

	else{
	    if( theNumber.charAt(0)=='"' && theNumber.charAt(theNumber.length()-1)=='"' )
		theNumber = theNumber.substring( 1, theNumber.length()-2 );


	    if(theNumber.equalsIgnoreCase("dk")){
		expo = 10000;
		sign = '/';
		fractionLength = -1;
	    }
	    else if(theNumber.equalsIgnoreCase("dc")){
		expo = -10000;
		sign = '/';
		fractionLength = -2;
	    }
	    else{
    		//  gets the exponent value
		char expSign = theNumber.charAt(0);
		if( expSign != '+' && expSign != '-' && expSign != ' ' ){
		    System.out.println( "Can not initiate object Number: Exponent sign not correct\n" 
					+ "The number is: "+theNumber );
		    throw new NumberFormatException();
		}
		
		//determin the position of the sign of the number
		int pos = theNumber.lastIndexOf('+');
		if(pos <= 0)
		    pos = theNumber.lastIndexOf('-');
		if(pos <= 0)
		    pos = theNumber.lastIndexOf(' ');
		if (pos <= 0 ){
		    System.out.println( "Can not initate object Number: Number format errorr, the sign of number must be: +|- |<space>.\n" );
		    throw new NumberFormatException();
		}
		if(pos > 5){
		    System.out.println("can not initate object Number: Number format error, Exponent length not correct.");
		    throw new NumberFormatException();
		}
		
		//exponent is stored as int value
		expo = (new Integer(theNumber.substring(1,pos))).intValue();
		if( expSign == '-' )
		    expo = -expo;
		
		sign = theNumber.charAt(pos);
		if( sign == ' ' ) sign = '+';
		
		fractionLength = theNumber.length()-(pos+1);
		
		fraction = new byte[ fractionLength ];
		for( int i=0; i<fractionLength; i++ ){
		    fraction[i] = (byte)(theNumber.charAt(i+pos+1)-48); //char 0 = Dec 48
		    //  checking the validity of the digits in the fraction part given.
		    if( fraction[i] < 0 || fraction[i] > 9 ){
			System.out.println( fraction[i] + " Fraction must be all digits 0-9 ...\n" );
			throw new NumberFormatException();
		    }
		}
		normalize();
	    }
	}
    }
    
    public number( char s, byte[] f, int e ) throws NumberFormatException
    {
	sign = s;
	fraction = new byte[ f.length ];
	
	for( int i=0; i<f.length; i++ ){
	    fraction[i] = f[i];
	    // checking the validity of the digits in the fraction part given.
	    if( fraction[i] < 0 || fraction[i] > 9 ){
		System.out.println( "Fraction must be all digits 0-9 ...\n" );
		throw new NumberFormatException();
		//System.exit( 1 );
	    }
	}
	
	if( isZero( fraction ) ){
	    fraction = new byte[1];
	    fractionLength=1;
	    iszero = true;
	}
	
	expo = e;
	if( expo > 9999 || expo < -9999 ){
	    System.out.println( expo + " Exponent must be between -9999 and 9999 ...\n" );
	    throw new NumberFormatException();
	    //          System.exit(1);
	}
	fractionLength = fraction.length;
    }
    
    
    public static number DK()
    {
   	number dk = new number("dk");
	return dk;
    }

    public static number DC()
    {
   	number dc = new number("dc");
    	return dc;
    }

    /********************************************************************
     * BASIC MATHEMATIC OPERATORS:	Add/Subtract/Multiply/Divide
     *
     * NOTE: add/subtract/multiply can up to any precision, depends on the
     *	     the construction of the input;
     *	     divide can precise only up to the default value "precision"
     *********************************************************************/

    /*---------------------------------------------------------
      |	add(number n) - add two real numbers, infinite precision
      |
      | steps: 1. shifting the smaller number in order to make
      |		  2 numbers' fraction parts agree with each other
      |	       2. determine whether to add or subtract according
      |		  to the sign of the numbers
      |	       3. check whether the exponent part need to be
      |		  advanced by one
      |	       4. return the sum
      ---------------------------------------------------------*/

      //yiyi revisited Aug'03
    public number add( number n )
    {
	number n2;	//a copy of n
	number n1; //a copy of the current number
   	byte[] fractionSum;
	int Exp;
	char SumSign;
	int diff = expo-n.expo;
	
      //  if(n.compareTo(number.DK()) == 0)
      //      return n;
        
	/*step one, number shift*/
	if ( diff >= 0 ){
	    n2 = n.shiftRight( diff );
	    n1 = new number(sign, fraction, expo);
	}
   	else{
	    n1 = shiftRight( -diff );
	    n2 = new number(n.sign, n.fraction, n.expo);
   	}
	Exp =n1.expo; 
	
	/*step two, determine whether to add or subtract*/
	if( n1.sign == n2.sign ){
	    fractionSum = byteAdd( n1.fraction, n2.fraction );
	    SumSign = n1.sign;
	    Exp += 1;
   	}
	else{
	    if((abs(n1)).compareTo(abs(n2)) < 0 ){
     		fractionSum = byteSubtract( n2.fraction, n1.fraction );
		SumSign = n2.sign;
	    }
	    else{
     		fractionSum = byteSubtract( n1.fraction, n2.fraction );
		SumSign = n1.sign;
	    }
	    
	    /*step 3, determine whether need to advance by one on exponent part*/
	    if( fractionSum[0] == 0 ){
		Exp += 1;
	    }
	    else{
		if(fractionSum[0] == 9){
		    int l = fractionSum.length-1;
		    byte[] tmp = new byte[l];
		    for(int i = 0; i<l;i++)
			tmp[i] = fractionSum[i+1];
		    fractionSum = tmp;
		}
	    }
   	}
	number s = new number( SumSign, fractionSum, Exp );
	s.normalize();
	return s;
  }
    
    /*----------------------------------------------------
      |	subtract(number n) - subtraction of 2 real numbers
      |
      | steps same as addition
      -----------------------------------------------------*/

    public number subtract( number n )
    {
  	number n1,n2;
   	byte[] fractionSub;
	int Exp;
	int diff = expo-n.expo;
	char SubSign;
	
	/*step one shift the smaller one to make the fraction part agree*/
  	if ( diff >= 0 ){
	    n2 = n.shiftRight( diff );
	    n1 = new number(sign, fraction, expo);
	}
  	else{
	    n1 = shiftRight( -diff );
	    n2 = new number(n.sign, n.fraction, n.expo);
   	}
	Exp = n1.expo; 
	
	/*step 2: determin the sign of the difference*/
   	if( n1.sign == n2.sign ){
	    if((abs(n1)).compareTo(abs(n2)) >= 0){
		fractionSub = byteSubtract( n1.fraction, n2.fraction );
		if(n1.sign == '+')
		    SubSign = '+';
		else
		    SubSign = '-';
	    }
	    else{
		fractionSub = byteSubtract(n2.fraction,n1.fraction);
		if(n1.sign == '+')
		    SubSign = '-';
		else
		    SubSign = '+';
	    }
	    /*step 3: determine whether the exponent part need to advance by one*/
	    if( n1.sign=='+' && fractionSub[0]==0){
		Exp += 1;
	    }
	    else{
		if(fractionSub[0] == 9){
		    int l = fractionSub.length-1;
		    byte[] tmp = new byte[l];
		    for(int i = 0; i<l;i++)
			tmp[i] = fractionSub[i+1];
		    fractionSub = tmp;
		}
	    }
	}
	else{
	    if( n1.sign=='+' )
		SubSign = '+';
	    else
		SubSign = '-';
	    fractionSub = byteAdd( n1.fraction, n2.fraction );
	    Exp += 1;
   	}
	number sub = new number( SubSign, fractionSub, Exp );
	sub.normalize();
	return sub;
    }
    
    public number multiply( number n )
    {
	int mExp = expo + n.expo;
	char mSign = sign==n.sign ? '+' : '-';
	byte[] mFraction;
	
	if( fractionLength >= n.fractionLength )
	    mFraction = byteMult( fraction, n.fraction );
	else
	    mFraction = byteMult( n.fraction, fraction );
	
	number m = new number( mSign, mFraction, mExp );
	m.normalize();
	return m;
    }
    

    public number divide( number n )
    {
	number n1 = new number(sign,fraction,expo);
	number n2 = new number(n.sign,n.fraction,n.expo);
	byte[] dFraction;
	n1.normalize();
	n2.normalize();
	
	int dExp = n1.expo - n2.expo;
  	char dSign = n1.sign==n2.sign ? '+' : '-';;
   	dFraction = byteDivide( n1.fraction, n2.fraction, precision );
	
	if( dFraction[0]!=0 ){
	    dExp += 1;
	}
  	else{
	    dFraction = byteShiftLeft( dFraction, 1 );
	}
	number d = new number( dSign, dFraction, dExp );
	d.normalize();
	return d;
    }
    
    /************************************************************
     *	MATHEMATICAL OPERATIONS USING STATIC METHODS
     *	ASSEMBLE TO JAVA.MATH CLASS
     ************************************************************/

    /*-------------------------------------------
     * NUMBER.MAX(NUMBER N1, NUMBER N2)
     *
     *	PARAMETERS: real numbers
     *	RETURN: the lagger number of n1 and n2
     *-------------------------------------------*/

    public static number max(number n1, number n2)
    {
	if(n1.compareTo(n2) > 0)
	    return n1;
	else
	    return n2;
    }
    
    /*----------------------------------------
     * NUMBER.MIN(NUMBER N1, NUMBER N2)
     *
     * PARAMETERS: real numbers
     *	RETURN: the smaller number of n1, n2
     *----------------------------------------*/
    
    public static number min(number n1, number n2)
    {
	if(n1.compareTo(n2) < 0)
	    return n1;
	else return n2;
    }
    
    /*----------------------------------------
     * NUMBER.ABS(NUMBER M)
     *
     * PARAMATER: real number
     *	RETURN: the absolute value of m
     *----------------------------------------*/
    
    public static number abs(number m)
    {
	number n = new number(m.sign,m.fraction,m.expo);
	n.sign = '+';
	return n;
    }

    /*-----------------------------------------
     *	 NUMBER.ROUND(NUMBER M)
     *
     *	PARAMETER: real number
     * RETURN: the nearest integer value of m
     *------------------------------------------*/

    public static number round(number m)
    {
	number n = new number(m.sign,m.fraction,m.expo);
	if (n.expo < 0){
	    n = new number("+000 0");
	    return n;
	}
	if (n.expo == 0){
	    if(n.fraction[n.expo] >= 5)
		n = new number("+001 1");
	    else
		n = new number("+000 0");
	    return n;
	}
	int firstDec = n.expo -1;	
	if(n.expo >= n.fractionLength)
	    return n;
	if (n.fraction[n.expo] >= 5)
	    n.fraction[firstDec] += 1;
	while(n.fraction[firstDec] == 10){
	    n.fraction[firstDec] = 0;
	    firstDec --;
	    n.fraction[firstDec] += 1;
	}
	byte tmp[] = new byte[n.expo];
	System.arraycopy(n.fraction,0,tmp,0,n.expo);
	n.fraction  = tmp;
	n.fractionLength = n.expo;
	return n;
    }
    
    
    /*----------------------------------------------
     * NUMBER.CEIL(NUMBER M)
     *
     * PARAMTER: real number
     *	RETURN: the ceiling int value of m
     *-----------------------------------------------*/
    
    public static number ceil(number m)
    {	//note: number.ceil(x) == -number.ceil(-x)
	number n = new number(m.sign,m.fraction,m.expo);
	if(n.expo >= n.fractionLength)
	    return n;
	if (n.expo <= 0){
	    String s = String.valueOf(n.sign);
	    String str = "+001" + s + "1";
	    n = new number(str);
	    return n;
	}
	int firstDec = n.expo -1;
	n.fraction[firstDec] += 1;
	while(n.fraction[firstDec] == 10){
	    n.fraction[firstDec] = 0;
	    firstDec --;
	    n.fraction[firstDec] += 1;
	}
	byte tmp[] = new byte[n.expo];
	System.arraycopy(n.fraction,0,tmp,0,n.expo);
	n.fraction = tmp;
	n.fractionLength = n.expo;
	return n;
    }
    
    /*-------------------------------------------
     *	NUMBER.FLOOR(NUMBER M)
     *
     * PARAMETER: real number
     * RETURN: the floor in value of m
     *-------------------------------------------*/
    
    public static number floor(number m)
    {
	number n = new number(m.sign,m.fraction,m.expo);
	if(n.expo >= n.fractionLength)
	    return n;
	if (n.expo <= 0){
	    n = new number("+000 0");
	    return n;
	}
	byte tmp[] = new byte[n.expo];
	System.arraycopy(n.fraction,0,tmp,0,n.expo);
	n.fraction = tmp;
	n.fractionLength = n.expo;
	return n;
    }
    
    /*-----------------------------------------------
     *	NUMBER.MOD(NUMBER N, NUMBER M)
     *
     * PARAMETERS: n - integer number
     *		   m - non-negative integer number
     *	RETURN: n mod m
     *
     *	NOTE: n mod m = n-floor(n/m)*m
     *-------------------------------------------------*/
    
    public static number mod(number n, number m)
    {
	if(!n.isInt() || !m.isInt()){
	    System.out.println("--error--modulo non-integer types");
	    System.exit(1);    
	}
	if(m.sign == '-'){
	    System.out.println("--error--modulo negative number");
	    System.exit(1);
	}
	return n.subtract((floor(n.divide(m))).multiply(m));
    }
    
    

    /*********************************************
     * The fllowing methods all take the absolute
     *	error less than 10 to the minus precision
     **********************************************/
    
    /*------------------------------------------
     *	NUMBER.SQRT(NUMBER X)
     *
     *	INPUT: x non-negative number
     * RETURN: sqare root of x
     *
     *	NOTE: applying newton's method
     *	         Gn+1 = (Gn + x/Gn)/2
     *	      where the first guess G1 takes X/8
     *-------------------------------------------*/
    public static number sqrt(number x)
    {
	number zero = new number("+000 0");
	if(x.sign == '-'){
	    System.out.println(x + " --error--negative sqrt");
	    System.exit(1);
	}
	if(x.compareTo(zero) == 0)
	    return zero;
	number one = new number("+001 1");
	if(x.compareTo(one) == 0)
	    return one;
	number ten = new number("+002+1");
	number pre = intToNum(precision);
	number eight = new number("+001 8");
	number two = new number("+001 2");
	number half = one.divide(two);
	number bound =one.divide(simPow(ten,pre));
	number guess = x.divide(eight);
	number guess1 = half.multiply(guess.add(x.divide(guess)));
	number err = abs(guess.subtract(guess1));
	while(err.compareTo(bound)>= 0){
	    guess = guess1;
	    guess1 = half.multiply(guess.add(x.divide(guess)));
	    err = abs(guess.subtract(guess1));
	}
	return guess1;
    }
    
    /*------------------------------------------------
      | exp(number x)
      |
      |	PARAMTER: real number
      | RETURN: the exponentail number of x
      |
      | NOTE: use taylor's series center at 0
      |	      exp(x) = Sum{X^k/K!}
      ---------------------------------------------------*/
    
    
    public static number exp(number x)
    {
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number one = new number("+001+1");
	number k = new number("+000+0");
	number pre = intToNum(precision);
	number bound =one.divide(simPow(ten,pre)); 
	number n = simPow(x,k).divide(fact(k));
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>=0){
	    k = k.add(one);
	    n = simPow(x,k).divide(fact(k));
	    sum = sum.add(n);
       err = abs(n.divide(sum));
	}
	return sum;
    }
    
    /*---------------------------------------------
      | ln(number x)
      |
      | PARAMTER: real number
      | RETURN: the nautral logrithm of x
      |
      | NOTE: 1. use taylor's series center at 1
      |		 ln(x+1) = Sum{(-1)^k*X^k/K}
      |		 for -1 <= x < 1
      |	      2. for x not in the domain [-1,1),
      | 	 use the trick that X = pow(e,b)*a
      |		 -> ln(x) = b + ln(a)
      |		 where -1 <= a <1
      ----------------------------------------------*/
    public static number ln(number x)
    {
	number one = new number("+001+1");
	number two = new number("+001+2");
	number zero = new number("+000+0");
	number e = exp(one);
	one = new number("+001+1");
	if(x.compareTo(e) == 0)
	    return one;
	if(x.sign == '-'){
	    System.out.println(x + "--error--x<=0");
	    System.exit(1);
	}
	if(x.compareTo(one) == 0)
	    return zero;
	if(x.compareTo(zero) > 0 && x.compareTo(two) < 0){
	    return simLn(x.subtract(one));
	}
	else{
	    number a = x;
	    number b = zero;
	    while(a.compareTo(zero) <= 0 || a.compareTo(two) >= 0){
		a = a.divide(e);
		b = b.add(one);
	    }
	    return (simLn(a.subtract(one))).add(b);
	}
    }
    
    /*-----------------------------------------------
      | log(number x)
      |
      |	PARAMETER: real number
      | RETURN: logarithm of base 10 of x
      |
      |	NOTE: apply the rule log(x) = ln(x)/ln(10)
      ------------------------------------------------*/
    public static number log(number x)
    {
	number zero = new number("+000+0");
	number one = new number("+001+1");
	number count = zero;
	if(x.sign == '-'){
	    System.out.println(x + "--error--x<=0");
	    System.exit(1);
	}
	number ten = new number("+002+1");
	number temp = x.divide(ten);
	while(temp.isInt()){
	    count = count.add(one);
	    temp = temp.divide(ten);
	}
	temp = temp.multiply(ten);
	if(temp.compareTo(one) == 0)
	    return count;
	else
	    return (ln(x).divide(ln(ten)));
    }

    /*-----------------------------------------------
      | lg(number x)
      |
      |	PARAMETER: real number
      | RETURN: logarithm of base 2 of x
      |
      |	NOTE: apply the rule lg(x) = ln(x)/ln(2)
      ------------------------------------------------*/
    public static number lg(number x)
    {
	number zero = new number("+000+0");
	if(x.sign == '-'){
	    System.out.println("--error--x<=0");
	    System.exit(1);
	}
	number two = new number("+001+2");
	number one = new number("+001+1");
	number count = zero;
	number temp = x.divide(two);
	while(temp.isInt()){
	    count = count.add(one);
	    temp = temp.divide(two);
	}
	temp = temp.multiply(two);
	if(temp.compareTo(one) == 0)
	    return count;
	else
	    return (ln(x).divide(ln(two)));
    }
    
    /*---------------------------------------------
      | pow(number a, number x)
      |
      | PARAMTERS: real numbers
      | RETURN: power of a to x
      |
      | NOTE: x is integer, looping multiply x
      |	      x is not integer, using taylor's series
      |	      pow(a,x) = Sum{(x*ln(a))^k/K!}
      -----------------------------------------------*/
    
    public static number pow(number a, number x)
    {
	if(x.isInt())
	    return simPow(a,x);
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number one = new number("+001+1");
	number k = new number("+000+0");
	number pre = intToNum(precision);
	number bound = one.divide(simPow(ten,pre));
	number inner = x.multiply(ln(a));
	number n = simPow(inner,k).divide(fact(k));
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>=0){
	    k = k.add(one);
	    n = (simPow(inner,k).divide(fact(k)));
	    sum = sum.add(n);
	    err = abs(n.divide(sum));
			}
	return sum;
    }
    
    /*************************************************
     * Trigonometric Functions
     * sin/cos/tan
     * asin/acos/atan
     * sinh/cosh/tanh
     *
     * NOTE: all parameters are in radian not degree!
     ***************************************************/
    
    /*----------------------------------------------
      | cos(number x)
      |
      | PARAMETER: real number
      | RETURN: cos(x)
      |
      | NOTE: use taylor's series:
      |	      cos(x) = Sum{(-1)^k*X^(2k)/(2K)!}
      ------------------------------------------------*/
    public static number cos(number x)
    {
	number one = new number("+001+1");
	number minusone = new number("+001-1");
	number zero = new number("+000+0");
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number k = new number("+000+0");
	number two = new number("+001+2");
	number pi = pi();
	if(x.compareTo(zero)==0)
	    return one;
	if(x.compareTo(pi)==0)
	    return minusone;
	if(x.compareTo(pi.divide(two)) == 0)
	    return zero;
	number pre = intToNum(precision);
	number bound = one.divide(simPow(ten,pre));
	number sk = k.multiply(two);
	number n = simPow(x,sk).divide(fact(sk));
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>0){
	    k = k.add(one);
	    sk = k.multiply(two);
	    n = (simPow(x,sk).divide(fact(sk))).multiply(simPow(minusone,k));
	    sum = sum.add(n);
	    err = abs(n.divide(sum));
	}
	return sum;
    }


    /*----------------------------------------------
      | sin(number x)
      |
      | PARAMETER: real number
      | RETURN: sin(x)
      |
      | NOTE: use taylor's series:
      |	      sin(x) = Sum{(-1)^k*X^(2k+1)/(2K+1)!}
      ------------------------------------------------*/
    public static number sin(number x)
    {
	number one = new number("+001+1");
	number minusone = new number("+001-1");
	number zero = new number("+000+0");
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number k = new number("+000+0");
	number two = new number("+001+2");
	number three = new number("+001+3");
	number pi = pi();
	if(x.compareTo(pi) == 0 || x.compareTo(zero)==0)
	    return zero;
	if(x.compareTo(pi.divide(two))==0)
	    return one;
	if(x.compareTo(pi.multiply(three).divide(two)) == 0)
	    return minusone;
	number pre = intToNum(precision);
	number bound = one.divide(simPow(ten,pre));
	number sk = (k.multiply(two)).add(one);
	number n = simPow(x,sk).divide(fact(sk));
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>=0){
	    k = k.add(one);
	    sk = (k.multiply(two)).add(one);
	    n = (simPow(x,sk).divide(fact(sk))).multiply(simPow(minusone,k));
	    sum = sum.add(n);
	    err = abs(n.divide(sum));
	}
	return sum;
    }
    
    /*----------------------------------------------
      | tan(number x)
      |
      | PARAMETER: real number in (-pi/2, pi/2)
      | RETURN: tan(x)
      |
      | NOTE: apply the rule tan(x) = sin(x)/cos(x)
      ------------------------------------------------*/
    public static number tan(number x)
    {
	number one = new number("+001 1");
	number two = new number("+001+2");
	number four = new number("+001 4");
	number pi4 = pi().divide(four);
	number pi2 = simPow((pi().divide(two)), two);
	if(x.multiply(x).compareTo(pi2) >= 0){
	    System.out.println("--error--tan out of range");
	    System.exit(1);
	}
	if(x.compareTo(pi4) == 0)
	    return one;
	if(x.compareTo(negate(pi4)) == 0)
	    return negate(one);
	return (sin(x).divide(cos(x)));
    }

    /*---------------------------------------------------------------
      | arcsin(number x)
      |
      | PARAMETER: real number in [-1,1]
      | RETURN: arcsin(x)
      |
      | NOTE: for x= +-1, arcsin(1) = +- pi/2
      |	      for x=0, arcsin(0) = 0
      |	      for x in (-1,1), use taylor's series
      |	      arcsin(x) = Sum{(2*(2K)!*(x/2)^(2k+1)/((K!)^2*(2K+1))}
      -----------------------------------------------------------------*/
    
    
    public static number arcsin(number x)
    {
	number one = new number("+001+1");
	number minusone = new number("+001-1");
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number k = new number("+000+0");
	number two = new number("+001+2");
	number zero = new number("+000 0");
	number b = new number("+000 8");
	if(x.multiply(x).compareTo(one) > 0){
	    System.out.println("--error--arcsin out of range");
	    System.exit(1);
	}
	if(x.compareTo(one) == 0)
	    return pi().divide(two);
	if(x.compareTo(minusone) == 0)
	    return negate(pi().divide(two));
	if(x.compareTo(zero) == 0)
	    return zero;
	number pre = intToNum(precision);
	number bound = one.divide(simPow(ten,pre));
	number sk = k.multiply(two);
	number sk2 = sk.add(one);
	number dk = x.divide(two);
	number n = x;
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>=0){
	    k = k.add(one);
	    sk = k.multiply(two);
	    sk2 = sk.add(one);
	    n = fact(sk).divide(simPow(fact(k),two)).multiply(simPow(dk,sk2)).divide(sk2).multiply(two);
	    sum = sum.add(n);
	    err = abs(n.divide(sum));
	}
	return sum;
    }

    /*----------------------------------------------
      | arccos(number x)
      |
      |	PARAMETER: real number in [-1,1]
      |	RETURN: arccos(x)
      |
      | NOTE: use the rule: asin(x) + acos(x) = pi/2
      ------------------------------------------------*/
    public static number arccos(number x)
    {
	number one = new number("+001 1");
	number two = new number("+001 2");
	if(x.multiply(x).compareTo(one) > 0){
	    System.out.println("--error--arccos out of range");
	    System.exit(1);
	}
	return (pi().divide(two).subtract(arcsin(x)));
    }
    
    /*-------------------------------------------------------------------
      | arctan(number x)
      |
      | PARAMETER: real number
      | RETURN: arctan(x)
      |
      | NOTE: for abs(x) = 1, use atan(x) + atan(y) = atan((x+y)/(1-x*y))
      |		 where x = 1/2, y = 1/3
      |	      for abs(x) > 1, use atan(x) = acos(1/sqrt(1+x[2]))
      |	      for abs(x) < 1, use atan(x) = Sum{(-1)^k*X^(2k+1)/(2K+1)}
      --------------------------------------------------------------------*/

    public static number arctan(number x)
    {
	number one = new number("+001+1");
	int comp = x.multiply(x).compareTo(one);
	number result = one;
	if(comp < 0)
	    result = simArctan(x);
	else if(comp == 0){
	    number two = new number("+001+2");
	    number three = new number("+001+3");
	    result = simArctan(one.divide(two)).add(simArctan(one.divide(three)));
	    if(x.compareTo(one) != 0)
		result = negate(result);
	}
	else{
	    number tmp = one.divide(sqrt(one.add(x.multiply(x))));
				return arccos(tmp);
	}
	return result;
    }

    /*---------------------------------------------------------------
      | arctan2(number x, number y)
      |
      |	PARAMETERS: x - the absissa coordinate
      |		    y - the ordinate coordinate
      | RETURN: the theta component of the point (r, theta) in polar
      |		coordinates that corresponds to the point (x, y) in
      |		Cartesian coordinates
      |	        It only takes in one circle[0,2pi], result is positive
      |
      | NOTE: arctan(x,y) = arctan(y/x) = arctan(tan(theta)) = theta
      -------------------------------------------------------------*/

    public static number arctan2(number x, number y)
    {
	number zero = new number("+000 0");
	number two = new number("+001 2");
	number n = y.divide(x);
	number result = zero;
	if(x.compareTo(zero) > 0 && y.compareTo(zero) > 0 )
	    result = arctan(n);
	else if(x.compareTo(zero) < 0)
	    result = pi().add(arctan(n));
	else if(x.compareTo(zero) > 0 && y.compareTo(zero) < 0)
	    result = pi().multiply(two).add(arctan(n));
	else;
	return result;
    }


    /**************************************************
     | HYPERBOLIC FUNCTIONS & THEIR INVERSE FUNCTIONS
     | sinh(x)/cosh(x)/tanh(x)
     | arcsinh(x)/arcosh(x)/arctanh(x)
     |
     | NOTE: All hyperbolic functions have domain R
    ***************************************************/

    /*----------------------------------------
      | sinh(number x)
      |
      | PARAMETER: x - a real number
      | RETURN: sinh(x) = (exp(x)-exp(-x))/2
      -------------------------------------------*/
    public static number sinh(number x)
    {
	number two = new number("+001+2");
	return (exp(x).subtract(exp(negate(x)))).divide(two);
    }

    /*-----------------------------------------
      | cosh(number x)
      |
      |	PARAMETER: x- real number
      | RETURN: cosh(x) = (exp(x)+exp(-x))/2
      -------------------------------------------*/
    public static number cosh(number x)
    {
	number two = new number("+001+2");
	return (exp(x).add(exp(negate(x)))).divide(two);
    }
    
    /*------------------------------------------
      | tanh(number x)
      |
      | PARAMETER: x - real number
      | RETURN: tanh(x) = sinh(x)/cosh(x)
      ------------------------------------------*/
    public static number tanh(number x)
    {
	return sinh(x).divide(cosh(x));
    }
    
    /*-----------------------------------------
      | arcsinh(x)
      |
      | PARAMETER: x - real number
      | RETURN: arcsinh(x) = ln(x + sqrt(x^2+1))
      ------------------------------------------*/
    public static number arcsinh(number x)
    {
	number one = new number("+001 1");
	number two  = new number("+001 2");
	number n = sqrt(simPow(x,two).add(one)).add(x);
	return ln(n);
    }
    
    /*-----------------------------------------
      | arcosh(x)
      |
      | PARAMETER: x - real number where x >= 1
      | RETURN: arcosh(x) = ln(x+sqrt(x^2-1))
      -------------------------------------------*/
    public static number arcosh(number x)
    {
	number one = new number("+001 1");
	if(x.compareTo(one) < 0){
	    System.out.println("--error--arcosh out of range");
	    System.exit(1);
	}
	number two = new number("+001 2");
	number n = sqrt(simPow(x,two).subtract(one)).add(x);
	return ln(n);
    }
    
    /*--------------------------------------------
      | arctanh(x)
      |
      | PARAMETER: x - real number in (-1,1)
      | RETURN: arctanh(x) = ln((1+x)/(1-x))/2
      ---------------------------------------------*/
    public static number arctanh(number x)
    {
	number one = new number("+001 1");
	if(abs(x).compareTo(one) >= 0){
	    System.out.println("--error--arctanh out of range");
	    System.exit(1);
	}
	number two = new number("+001 2");
	number n = one.add(x);
	number m = one.subtract(x);
	return one.divide(two).multiply(ln(n.divide(m)));
    }
    
    /*-----------------------------------------------------
      | pi()
      |
      | RETURN: the number pi using the rule arctan(1) = pi/4
      ------------------------------------------------------*/
    public static number pi()
    {
	number one = new number("+001+1");
	number four = new number("+001+4");
	return four.multiply(arctan(one));
    }
    
    /*---------------------------------------------------------
      | comnpareTo(number n) - compare the exists number with n
      |
      | PARAMETER: n - real number
      |	RETURN: 0 - if they are equal
      | 	-1- if less than n
      |         1 - if greater than n
      |
      | Note: in the case of NUMERIC_DC & NUMERIC_DK, 
      |       if n is one of the above, n is greater
      |       if DC & DK is being compared, the one who
      |       is set as n will be the greater one
      ---------------------------------------------------------*/
    
    public int compareTo(number n)
    {
	if(sign == n.sign){
	    if(sign == '/'){
		if(expo == n.expo)
		    return 0;
		else
		    return -1;
	    }
	    else if(sign == '-'){
		if(expo > n.expo) return -1;
		else if(expo < n.expo) return 1;
		else{
		    if(byteCompare(fraction, n.fraction)==0)
			return 0;
		    else if(byteCompare(fraction, n.fraction)==-1)
			return 1;
		    else return -1;
		}
	    }
	    else{//sign=='+'
		if(expo > n.expo){
      	if(isZero(fraction))
         	return -1;
       	else return 1;
  		}
		else if(expo < n.expo){
      	if(iszero(n))
         	return 1;
       	else return -1;
  		}
		else{
		    if(byteCompare(fraction,n.fraction)==0)
			return 0;
		    else if(byteCompare(fraction, n.fraction)==-1)
			return -1;
		    else return 1;
		}
	    }
	}
	else{//sign!=n.sign
	    if(sign == '+') return 1;
	    else return -1;
	}
    }



    /*********************************************************
     * CONVERSION METHODS
     *
     * 1. converts premitive types to numeric
     *		 int/short/long/double/float to numeric
     *
     * 2. converts numeric(infinite precision) to premitive
     *    types: round the the excessive digits
     *		 numeric to int/long/double
     **********************************************************/
    
    /*------------------------------------------------------
      | intToNum(int n)
      |
      | PARAMETER: n - premitive int number, 32 bits
      |		       value in [-2147483648, 2147483647]
      | RETURN: The numeric expression of n
      --------------------------------------------------------*/
    public static number intToNum(int n)
    {
	String ex = Integer.toString(n);
	int e = n >= 0? ex.length():ex.length() -1;
	String s = "+" + combine(Integer.toString(e));
	if(n >= 0)
	    s += "+";
	s += ex;
	number m = new number(s);
	return m;
    }
    
    /*-------------------------------------------------
      | longToNum(long n)
      |
      | PARAMETER: n - premitive long number,64 bits
      |		       value in [-9223372036854775808,
      |		       9223372036854775807]
      | RETURN: the numeric expression of n
      ---------------------------------------------------*/
    public static number longToNum(long n)
    {
	String ex = Long.toString(n);
	int e = n >= 0? ex.length() : ex.length() - 1;
	String s = "+" + combine(Integer.toString(e));
	if(n >= 0)
	    s += "+";
	s += ex;
	number m = new number(s);
	return m;
    }

    /*--------------------------------------------------
      | shortToNum(short n)
      |
      | PARAMETER: n - premitive short number, 16 bits
      |		       value in [-32768,32768]
      | RETURN: the numeric expression of n
      ----------------------------------------------------*/
    public static number shortToNum(short n)
    {
	String ex = Short.toString(n);
	int e = n >= 0? ex.length() : ex.length()-1;
	String s = "+" + combine(Integer.toString(e));
	if(n >= 0)
	    s += "+";
	s += ex;
	number m = new number(s);
	return m;
    }
    
    /*-------------------------------------------------------
      | doubleToNum(double n)
      |
      | PARAMETER: n - premitive double number
      |		       value in [-1.7E+308,1.7E+308]
      | RETURN:	numeric expression of n
      |
      |	NOTE: java double number has 2 expression, such as
      |	      ***.*** and *.****E+***, hence the conversion
      |	      must check both the decimal point and the E
      ------------------------------------------------------*/
    public static number doubleToNum(double n)
    {
	String s;
	String si = n>=0?"+":"";
	String num = Double.toString(n);
	int ePos = num.indexOf("E");
	if(ePos < 0){
	    //in the case of ***.***
	    int decPos = num.indexOf(".");
	    s = "+"+combine(Integer.toString(decPos))+si+num.substring(0,decPos)+num.substring(decPos+1);
	}
	else{
	    //in the case of *.***E+***
	    int ex = Integer.parseInt(num.substring(ePos+1));
	    ex += 1;
	    String esig = ex>=0?"+":"-";
	    String e = combine(Integer.toString(Math.abs(ex)));
	    s = esig+e+si+num.substring(0,1)+num.substring(2,ePos);
	}
	number m = new number(s);
	return m;
    }
    
    /*----------------------------------------------
      | floatToNum(float n)
      |
      | PARAMETER: n - premitive float number
      | RETURN: numeric expression of ns
      ------------------------------------------------*/
    public static number floatToNum(float n)
    {
	number m = doubleToNum((double)n);
	return m;
    }
    

    /*-------------------------------------------------
      | numToInt()/numToLong()/numToDouble()
      |
      | RETURN: the premitive expression of the current
      |		numeric number, if current numeric out
      |		of range, a zero will be returned
      |
      | NOTE: the current numeric has to be within the range
      |	      of the corresponding coverted premitive type
      |	      otherwise, a NumberFormatException will be
      |	      thrown
      ---------------------------------------------------*/
    public int numToInt()
    {
	int m;
	try{
	    normalize();
	    String num = fracToString();
	    m = Integer.parseInt(num);
	    m*=(int)(Math.pow(10,(double)(expo-fractionLength)));
	    if(sign == '-')
		m*=-1;
	}
	catch(NumberFormatException e){
	    m = 0;
	}
	return m;
    }
    
    public long numToLong()
    {
	long m;
	try{
	    normalize();
	    String num = fracToString();
	    m = Long.parseLong(num);
	    m *= (long)(Math.pow(10,(double)(expo-fractionLength)));
	    if(sign == '-')
		m *= -1;
	}
	catch(NumberFormatException e){
	    m = 0;
	}
	return m;
    }
    
    public short numToShort()
    {
   	short m;
    	try{
	    normalize();
	    String num = fracToString();
	    m = Short.parseShort(num);
	    m *= (short)(Math.pow(10,(double)(expo-fractionLength)));
	    if(sign == '-')
         	m *= -1;
	}
	catch(NumberFormatException e){
	    m = 0;
	}
	return m;
    }
    
    public double numToDouble()
    {
	double m;
	try{
	    normalize();;
	    String num = fracToString();
	    m = Double.parseDouble(num);
	    m *= (double)(Math.pow(10,(double)(expo-fractionLength)));
	    if(sign == '-')
		m *= -1;
	}
	catch(NumberFormatException e){
	    m = 0.0;
	}
	return m;
    }
    
    public String toString()
    {
	String theNumber;
   	String theExp;
	String theFraction;
	if(fractionLength == -1)
	    theNumber = "dk";
	else if(fractionLength == -2)
	    theNumber = "dc";
	else{
	    if( iszero )
		return "+000 0";
	    byte[] fb = new byte[ fractionLength ];
	    for( int i=0; i<fractionLength; i++ )
   		fb[i] = (byte) (fraction[i]+48);
	    theFraction = new String( fb );
	    if( sign == '-' )
		theFraction = "-"+theFraction;
	    else
		theFraction = "+"+theFraction;
	    int expVal = expo>0 ? expo : -expo ;
	    theExp = Integer.toString(expVal);
	    while( theExp.length() < 3 )
		theExp = "0"+theExp;
	    if( expo < 0 )
		theExp = "-"+theExp;
	    else
		theExp = "+"+theExp;
	    theNumber = theExp+theFraction;
	}
	return theNumber;
    }
    
    /*****************************************************************
     *	MINOR METHODS: help the implementation of the major operations
     *
     * The correspondances are as the followings:
     *
     * byteAdd -- add
     * byteSubtract - subtract/add
     * byteMult - multiply
     * byteDivide - divide
     * singleDigitMult - byteMult/byteDivide
     * negate
     * SimPow - pow/etc
     * fact - pow/ln/sin/cos/etc
     * simLn - ln
     * simArctan - arctan
     * isInt
     * normalize
     * shiftRight - add/subtract
     * shiftLeft - normalize
     * byteShiftRight - shiftRight
     * byteShiftLeft - shiftLeft
     * roundLastDigit - byteDivide
     * iszero
     * setPrecision
     * byteCompare - compareTo
     * combine - conversion methods
     * fracToString
     ******************************************************************/
    
    
    /*------------------------------------------------------------------
      | byteAdd(byte[] a, byte[] b): Add the fraction part of 2 numbers
      |
      |	PARAMETERS: a, b - byte arrays of 2 numeric numbers' fraction
      |			   parts, assume has already been shifted,
      |			   i.e. their decimal points are consist with
      |			   each other
      |	RETURN: byte array of the fraction sum of a and b
      -----------------------------------------------------------------*/
    byte[] byteAdd( byte[] a, byte[] b )
    {
   	int lg = (a.length>b.length?a.length:b.length) +1;
	int sht = a.length>b.length?b.length:a.length;
	int tmp;
	byte[] s = new byte[lg];	//array of fraction sum
	byte[] c = new byte[lg];	//array of advanced one per digit addition
	int i;
	
	if( a.length>=b.length ){
	    for( i=0; i<lg-1; i++ ){
     		s[i+1]=a[i];
	    }
	    for( i=sht-1; i>=0; i-- ){
    		tmp = s[i+1]+b[i]+c[i+1];
		c[i] = (byte) (tmp/10);
		s[i+1] = (byte) (tmp%10);
	    }
   	}
	else{
	    for( i=0; i<lg-1; i++ )
     		s[i+1]=b[i];
	    for( i=sht-1; i>=0; i-- ){
		tmp = s[i+1]+a[i]+c[i+1];
		c[i] = (byte) (tmp/10);
		s[i+1] = (byte) (tmp%10);
	    }
	}
	s[0]=c[0];
	return s;
    }

    /*------------------------------------------------------------------
      | byteSubtract(byte[] a, byte[] b): subtract the fraction part of
      |					  2 numbers
      |
      |	PARAMETERS: a, b - byte arrays of 2 numeric numbers' fraction
      |			   parts, assume has already been shifted,
      |			   i.e. their decimal points are consist with
      |			   each other
      |	RETURN: byte array of the fraction difference of a and b
      -----------------------------------------------------------------*/
    byte[] byteSubtract( byte[] a, byte[] b )
    {
	int lgr = a.length>b.length ? a.length : b.length;
	int sht = a.length>b.length ? b.length : a.length;
	byte[] result = new byte[ lgr+1 ]; //array of fraction difference
	byte[] c = new byte[ sht+1 ];	//array of borrowed digits
	int i;
	
	if( a.length >= b. length ){
	    for( i=lgr-1; i>=sht; i-- )
        	result[i+1]=a[i];
	    for( ; i>=0; i-- ){        // get rid of all the 0's at the end of b
        	if( b[i] != 0 ) break;
         	result[i+1]=a[i];
     		}
	}
	else{
	    for( i=lgr-1; i>=sht; i-- )  // get rid of the 0's at the end of b
		if( b[i] != 0 ) break;
	    if( i>=sht ){
		result[i+1] = (byte) ((10-b[i])%10);
		i--;
		for(; i>=sht; i-- )
		    result[i+1] = (byte) (9-b[i]);
		c[sht] = 1;
	    }
   	}
	for( ; i>=0; i-- ){
	    if( a[i] == b[i] ){
    		result[i+1] = (byte)((a[i] + 10 - b[i] - c[i+1])%10);
		c[i] = c[i+1];
	    }
	    else if(a[i] < b[i]){
		result[i+1] = (byte)((a[i]+10-b[i]-c[i+1])%10);
		c[i] = 1;
	    }
	    else{
     		c[i] = 0;
		result[i+1] = (byte)(a[i] -b[i] - c[i+1]);
	    }
   	}
	result[0] = c[0];
	if(result[0] == 0 && result[1] == 0)
	    result[0] = 9;
   	if( result[0]==1 ){
	    /*  The result is negative. The current result array actually contains the
	     *  10's complement of the actual result. Need to the reverted.*/
	    for( i=lgr; i>=0; i-- )  // get rid of the 0's at the end, if any.
     		if( result[i] !=0 ) break;
	    result[i] = (byte) ( (10-result[i])%10 );
	    i--;
	    for( ; i>=1; i-- )
		result[i] = (byte) (9-result[i]);
	}
	return result;
    }
    
    /*------------------------------------------------------------------
      | byteMult(byte[] a, byte[] b): multiply the fraction part of 2 numbers
      |
      |	PARAMETERS: a, b - byte arrays of 2 numeric numbers' fraction
      |			   parts
      |	RETURN: byte array of the fraction product of a and b
      -----------------------------------------------------------------*/
    public byte[] byteMult( byte[] a, byte[] b )
    {
	int tmp;
	
	/*
	 *  These 2 variables are used for remembering the
	 *  results for the single digit multiplications.
	 *  There could be only 10 possible results. The value
	 *  is initiated at the time of first instance and is
	 *  used for following instances of any digit in b. For
	 *  example, if byte array b contains 10 8's. Only the
	 *  first time we met 8, we actually need to do the singleDigMult
	 *  of a by 8. In stead of doing the multiplication again
	 *  and again, we simply save that result. The next time we
	 *  come across 8 in b again, we just apply the result instead of
	 *  calling singleDigMult again.  This will save us a lot of
	 *  time when the size of a are very large.
	 */
	byte[][] temp = new byte[10][];
	byte[][] temp1 = new byte[10][];
	tmp = b[0];
	/*
	 *  We will keep the first digit returned by the first single digit multiplication
	 *  because there might be some carry value.
	 */
	byte[] result = singleDigitMult( a, tmp );
	for( int i=1; i<b.length; i++ ){
	    tmp = b[i];
	    if( b[i] == 0 ) continue;
	    /*
	     *  for a digit that is 0, no need to do any multiplication
	     */
	    
	    if( temp[ tmp ] == null ){
		/*
		 *  Only when temp[ b[i] ] is not initiated,i.e., it is the first time
		 *  we come accross the byte value b[i] in b, we do a single digit multiplication
		 */
        	temp[ tmp ] = singleDigitMult( a, tmp );
	    }
	    temp1[ tmp ] = byteShiftRight( temp[ tmp ], i );
	    result = byteAdd( result, temp1[ tmp ] );
	    result = byteShiftLeft( result, 1 );
            // starting from the 2nd digit, there need to be an adjustment
            // such that the 0 added to the front byte "byteAdd()" is cut off
            // otherwise the digits is not going to be correct.
	}
	return result;
    }
    
    /*------------------------------------------------------------------
      | byteDivide(byte[] a, byte[] b, int precision):
      |	       multiply the fraction part of 2 numbers
      |
      |	PARAMETERS: a, b - byte arrays of 2 numeric numbers' fraction
      |			   parts
      |	RETURN: byte array of the fraction quotient of a and b
      -----------------------------------------------------------------*/
    byte[] byteDivide( byte[] a, byte[] b, int precision )
    {
	if( precision > MaxDigNum ){
	    System.out.println( "byteDivid():  The maximum precision of result is preset to " + MaxDigNum + 
				" Digits only.\nTo increase possible digits:  reset MaxDigNum value.\n"+
				" To allow current setting to work:  reduce the precision required." );
	    System.exit(1);
	}
	byte[] aa = new byte[a.length+2];
	byte[] bb = new byte[b.length+2];
	byte[] c;
	byte[] d = new byte[precision+a.length+2];
	int tmp, dgcount, i;
	boolean DgCountStarted = false;
	
	/*
	 *  In order not to affect the value of a and b, we need
	 *  to make a copy of the operands.
	 */
	for( i=0; i<a.length; i++ )
	    aa[i] = a[i];
	for( i=0; i<b.length; i++ )
	    bb[i] = b[i];
	dgcount=0;
	i = 0;
	while( !isZero( aa ) && dgcount<=precision  ){
	    /*
	     *  Until the precision+1 digits is computed.
	     */
	    if( aa[i] == 0 ){
		bb=byteShiftRight( bb, 1 );
       		if( DgCountStarted ) dgcount++;
         	i++;
		continue;
	    }
	    if( aa[i] > bb[i] ){
        	tmp = (aa[i]*100+aa[i+1]*10+aa[i+2])/(bb[i]*100+bb[i+1]*10+bb[i+2]);
         	c = singleDigitMult( bb, tmp );
		c = byteShiftLeft( c, 1 );
		aa = byteSubtract( aa, c );
	    }
	    else if( aa[i] < bb[i] ){
        	i++;  //Skip this i, and keep d[i] unchanged
         	bb = byteShiftRight( bb, 1 );
		if( DgCountStarted ) dgcount++;
		tmp = (aa[i-1]*100+aa[i]*10+aa[i+1])/(bb[i-1]*100+bb[i]*10+bb[i+1]);
		c = singleDigitMult( bb, tmp );
		c = byteShiftLeft( c, 1 );
		aa = byteSubtract( aa, c );
	    }
	    else{  // aa[i]==bb[i]
        	aa = byteSubtract( aa, bb );
         	if( aa[0] == 1 ){
		    // aa is smaller than bb, the reminder is negative,
		    // we need to put the the bb back to aa and continue
		    // to the next step.
		    
		    aa = byteShiftLeft( aa, 1 );
		    aa = byteSubtract( bb, aa );
		    aa = byteShiftLeft( aa, 1 );
		    i++;  //Skip this i, and keep d[i] unchanged
		    bb = byteShiftRight( bb, 1 );
		    if( DgCountStarted ) dgcount++;
		    
		    tmp = (aa[i-1]*100+aa[i]*10+aa[i+1])/(bb[i-1]*100+bb[i]*10+bb[i+1]);
		    c = singleDigitMult( bb, tmp );
		    c = byteShiftLeft( c, 1 );
		    aa = byteSubtract( aa, c );
		}
		else{
		    tmp = 1;
		}
	    }
	    if( aa[0] == 1 ){
		/*
		 *  the remindar is negative, which means the remindar is
		 *  a little too big, we need to reduce it.
		 */
		tmp--;
		aa = byteShiftLeft( aa, 1 );
		aa = byteSubtract( bb, aa );
		aa = byteShiftLeft( aa, 1 );
	    }
	    else
        	aa = byteShiftLeft( aa, 1 );
	    d[i] = (byte) tmp;
	    if( !DgCountStarted && tmp !=0 ) DgCountStarted=true;
	    // Starting point for counting the effective digits
	    // for the result.
	}//end of while
     	byte[] dd;
	if( i < d.length ){
	    dd = new byte[i+1];
	    for( int k=0; k<=i; k++ )
		dd[k] = d[k];
	    return dd;
	}
	return d;
    }
    
    /*------------------------------------------------------------------
      | byteMult(byte[] a, int b)
      |
      | PARAMTERS: a - byte array of current number's fraction part
      |		   b - a digit in another number's fraction part
      | RETURN: a byte array of the product of b and a
      -----------------------------------------------------------------*/
    byte[] singleDigitMult( byte[] a, int b )
    {
	int ml = a.length+1;
   	byte[] m = new byte[ml];	//array of product
	byte[] c = new byte[ml];	//array of advanced digits
	int tmp;
	
	for( int i=ml-2; i>=0; i-- ){
	    tmp = a[i]*b+c[i+1];
	    c[i] = (byte) (tmp/10);
	    m[i+1] =  (byte) (tmp%10);
	}
	m[0]=c[0];
	return m;
    }
    
    /*--------------------------------------------
      | negate(number x)
      |
      | PARAMETER: x - real number
      | RETURN: the negative number of x
      ----------------------------------------------*/
    static number negate(number x)
    {
	number minus1 = new number("+001-1");
	return x.multiply(minus1);
    }
    
    /*-------------------------------------------------
      | simPow(number a, number x)
      |
      | PARAMTER: a,x - integer type numbers
      | RETURN: a^x
      ---------------------------------------------------*/
    static number simPow(number a, number x)
    {
	number one = new number("+001+1");
	number zero = new number("+000 0");
	number n = a;
	number l = x;
	int b = x.compareTo(zero);
	long limit = l.numToLong();
	if(b==0)
	    return one;
	else if(b > 0){
	    for(long i = 1; i < limit; i++)
		n = n.multiply(a);
	    return n;
	}
	else{
	    for(long i=1; i<limit; i++)
		n = n.multiply(a);
	    n = one.divide(n);
	    return n;
	}
    }
    
    
    /*--------------------------------------------------
      | fact(number n)
      |
      | PARAMTER: n - non-negative integer number
      | RETURN: factorial of n
      |
      | NOTE: use iteral fact algorithm instead of direct
      |				recursion to save storage
      ----------------------------------------------------*/
    
    /*	static number fact(number n)
	{
	number one = new number("+001+1");
	if(iszero(n)||n.compareTo(one)==0)
	return one;
	else
	return n.multiply(fact(n.subtract(one)));
	}*/
    
    static number fact(number n)
    {
	number zero = new number("+000 0");
	number one = new number("+001+1");
	return factIter(one,one,n);
    }
    
    static number factIter(number prod, number ct, number maxCt)
    {
	number one = new number("+001+1");
	if(ct.compareTo(maxCt) > 0)
	    return prod;
	else
	    return factIter(prod.multiply(ct),ct.add(one),maxCt);
    }
    
    /*---------------------------------------------------
      | simLn(number x)
      |
      | PARAMETER: x - real number in (-1,1)
      | RETURN: logarithm of x
      |
      | NOTE: applying taylor's series
      |				ln(1+x) = Sum{((-1)^(k-1))*(x^k/K)}
      |				stop computing when absolute error less than
      |				10 to the minus precision
      ----------------------------------------------------*/
    static number simLn(number x)
    {
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number one = new number("+001+1");
	number k = one;
	number minus1 = new number("+001-1");
	number pre = intToNum(precision);
	number sk = k.subtract(one);
	number bound = one.divide(simPow(ten,pre));
	number n = simPow(x,k).divide(k);
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>=0){
	    k = k.add(one);
	    sk = k.subtract(one);
	    n = (simPow(x,k).divide(k)).multiply(simPow(minus1,sk));
	    sum = sum.add(n);
	    err = abs(n.divide(sum));
	}
	return sum;
    }
    
    /*------------------------------------------------------
      | simArctan(number x)
      |
      | PARAMETER: x - real number in the range (-1,1)
      | RETURN: arctan(x)
      |
      | NOTE: apply taylor's series
      |				arctan(x) = Sum{(-1)^k * x^(2k+1) /(2k+1)}
      |				stop computing when absolute error less than
      |				10 to the minus precision
      -------------------------------------------------------*/
    public static number simArctan(number x)
    {
	number one = new number("+001+1");
	number ten = new number("+002+1");
	number four = new number("+001+4");
	number two = new number("+001+2");
	number minusone = new number("+001-1");
	number k = new number("+000+0");
	number pre = intToNum(precision);
	number sk = (k.multiply(two)).add(one);
	number bound = one.divide(simPow(ten,pre));
	number n = simPow(x,sk).divide(sk);
	number sum = n;
	number err = abs(n.divide(sum));
	while(err.compareTo(bound)>0){
	    k = k.add(one);
	    sk = (k.multiply(two)).add(one);
	    n = (simPow(x,sk).divide(sk)).multiply(simPow(minusone,k));
	    sum = sum.add(n);
	    err = abs(n.divide(sum));
	}
	return sum;
    }
    
    
    /*-----------------------------------------------
      | isInt() - check the current number whether is
      |						integer type
      | RETURN: true - current number is integer
      |         false - current number is non-integer
      ------------------------------------------------*/
    public boolean isInt()
    {
	normalize();
	return (expo >=fraction.length);
    }
    
    
    /*-------------------------------------------------------
      | normalize() - normalize the current number, i.e.get
      |		      rid of the 0's infront of the first
      |		      non-zero digit in fraction part
      |		      e.g./ -001-00064 ==> -004-64
      ----------------------------------------------------------*/
    public void normalize()
    {
	int ct=0;
	normal();
	while( ct<fraction.length && fraction[ct]==0 ) ct++;
	if( ct!=fraction.length )
	    shiftLeft( ct );
	else{
     	fraction=new byte[1];
	fractionLength=1;
   	}
    }
    
    /*---------------------------------------------------------
      | normal() - normalize the current number, i.e. get rid of
      |		   the 0's following the last non-zero digit in
      |		   fraction part
      |		   e.g.+002+6400 ==> +002+64
      ----------------------------------------------------------*/
    void normal()
    {
	int ct = 0;
	byte[] tmp;
	int l = fraction.length - 1;
	while( l>= 0 && fraction[l]==0){ ct++; l--;}
	if(!(fraction.length==ct)){
	    fractionLength = fraction.length-ct;
	    tmp = new byte[fractionLength];
	    System.arraycopy(fraction,0,tmp,0,fractionLength);
	    fraction = tmp;
	}
    }


    /*-------------------------------------------------------
      | shiftRight(int n)
      |
      | PARAMETER: n - number of digits need to be shifted
      | RETURN - shifted number
      ---------------------------------------------------------*/
    public number shiftRight(int n)
    {
  	int nexpo = expo + n;
	byte[] nfraction = fraction;
  	if( nexpo > 9999 ){
	    System.out.println( "Can not shift: exponent overflow!\n" );
	    System.exit(1);
   	}
	nfraction = byteShiftRight( nfraction, n );
	number ne = new number(sign, nfraction, nexpo);
	return ne;
    }
    
    /*--------------------------------------------------------
      | shiftLeft(int n) - shift the current number to the left
      | 		   n digits
      ---------------------------------------------------------*/
    public void shiftLeft( int n )
    {
	expo -= n;
	if( expo < -9999 ){
	    System.out.println( "Can not shift: expoonent underflow!\n" );
	    System.exit(1);
   	}
	fraction = byteShiftLeft( fraction, n );
	fractionLength -= n;
    }
    
    /*---------------------------------------------------
      | byteShiftRight(byte[] a, int n)
      |
      | PARAMTER: a - byte array to be shifted
      |		  n - number of digits need to be shifted
      |	RETURN: byte array of shifted a
      -----------------------------------------------------*/
    byte[] byteShiftRight( byte[] a, int n )
    {
   	if( n==0 ) return a;
	byte[] result = new byte[ a.length+n ];
	for( int i=0; i<a.length; i++ )
	    result[i+n] = a[i];
	return result;
    }

    /*---------------------------------------------------
      | byteShiftLeft(byte[] a, int n)
      |
      | PARAMTER: a - byte array to be shifted
      |		  n - number of digits need to be shifted
      |	RETURN: byte array of shifted a
      -----------------------------------------------------*/
    byte[] byteShiftLeft( byte[] a, int n )
    {
	if( n==0 ) return a;
   	byte[] result = new byte[ a.length-n ];
	for( int i=n; i<a.length; i++ )
	    result[i-n]=a[i];
	return result;
    }
    

    /*----------------------------------------------------
      |	roundLastDigit(byte[] a)
      |
      | PARAMTER: a - byte array (fraction part of current
      |				  number)
      | RETURN: a with last digit rounded
      ------------------------------------------------------*/
    byte[] roundUpLastDigit(byte[] a)
    {
	int tmp;
   	if( a[a.length-1] >= 5 ){
	    tmp = 1;
	    for( int i= a.length-1; i>0; i-- ){
		a[i] = (byte) ((a[i-1]+tmp)%10);
		tmp = (a[i-1]+tmp)/10;
	    }
	    a[0] = (byte) tmp;
	}
  	else{
	    for( int i=a.length-1; i>0; i-- )
     		a[i] = a[i-1];
	    a[0] = 0;
   	}
	return a;
    }

    /*---------------------------------------
      | isZero(byte[] a)
      |
      | check if the fraction part of current
      | number whether is zero
      ----------------------------------------*/
    boolean isZero( byte[] a )
    {
	for( int i=0; i<a.length; i++ ){
	    if( a[i] != 0 )
     		return false;
   	}
	return true;
    }
    
    /*---------------------------------------
      | iszero(number n)
      |
      | check whether number n is zero
      ----------------------------------------*/
    public static boolean iszero(number n)
    {
	number zero = new number("+000+0");
	return (n.compareTo(zero) == 0);
    }
    
    /*-----------------------------------
      | setPrecision(int pre)
      |
      | change the default precision
      -------------------------------------*/
    public void setPrecision(int pre)
    {
	if(pre < 0 || pre > MaxDigNum){
	    System.out.println("Precision out of boundary.");
	    System.exit(1);
	}
	precision = pre;
    }
    
    
    /*----------------------------------------------
      | byteCompare(byte[] a, byte[] b)
      |		             compare 2 fractions
      |
      | PARAMETERS: a,b - byte arrays of 2 numbers'
      |		          fraction parts
      |	RETURN: 0 - equal
      |		1 - a > b
      |		-1 - a < b
      -----------------------------------------------*/
    int byteCompare(byte[] a, byte[] b)
    {
	int shl = a.length > b.length? b.length : a.length;
	for(int i = 0; i< shl; i++){
	    if(a[i] == b[i]) continue;
	    else if(a[i] > b[i])
		return 1;
	    else
		return -1;
	}
	if(a.length == b.length)
	    return  0;
	else if(a.length > b.length)
	    return 1;
	else
	    return -1;
    }
    
    /*-------------------------------------------
      | combine(String s)
      |
      | returns the string expression of the exponent
      |	part of the number
      ----------------------------------------------*/
    static String combine(String s)
    {
	String re = "";
	int l = s.length();
	if(l == 1)
	    re = "00" + s;
	else if(l == 2)
	    re = "0" + s;
	else
	    re = s;
	return re;
    }
    
    /*-------------------------------------------
      | fractToString()
      |
      | returns the string expression of the current
      | number's fraction part
      ---------------------------------------------*/
    String fracToString()
    {
	byte[] fb = new byte[ fractionLength ];
	for( int i=0; i<fractionLength; i++ )
	    fb[i] = (byte) (fraction[i]+48);
	String theFraction = new String( fb );
	return theFraction;
    }
    
}
